import java.util.Vector;


public class BreadthFirstTree
{

	BreadthFirstNode root;
	Vector nodes;
	Vector currentLayerNodes;
	Vector newLayerNodes;
	int leftSize,rightSize;
	boolean leftContains[],rightContains[];

	BreadthFirstTree(BreadthFirstNode root, int leftSize, int rightSize)
	{
		this.root=root;
		nodes=new Vector();
		nodes.add(root);
		currentLayerNodes=new Vector();
		currentLayerNodes.add(root);
		this.leftSize=leftSize;
		this.rightSize=rightSize;
		leftContains=new boolean[leftSize];
		rightContains=new boolean[rightSize];
	}

	public BreadthFirstNode getRoot() { return root; }

	public Vector getCurrentLayer() { return currentLayerNodes; }

	public void updateLayer()
	{
		if (newLayerNodes != null)
		{
			currentLayerNodes = newLayerNodes;
			newLayerNodes= null;
		}
	}

	public boolean addNewLayerNode(BreadthFirstNode node)
	{
		if (node==null)
			return false;

		int nodeIndex=node.getIndex();
		int nodeSide=node.getSide();
		/* do not repeat the old nodes */
		if (nodeSide==Constants.LEFT)
		{
			if (leftContains[nodeIndex] == true)
				return false;
			else
				leftContains[nodeIndex] = true;
		}
		else if (nodeSide==Constants.RIGHT)
		{
			if (rightContains[nodeIndex] == true)
				return false;
			else
				rightContains[nodeIndex] = true;
		}
		if (newLayerNodes != null )
		{
			newLayerNodes= new Vector();
		}
		newLayerNodes.add(node);
		nodes.add(node);
		return true;
	}
}
