import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Random;
import java.util.Vector;

/*
 * Created on Apr 27, 2005
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
/**
 * @author bingan
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class CompleteTestCaseGenerator {
	EventGraph eventGraph;
	Vector[] eventGraphIndexVector;
	private int testCaseID=0;
	private Vector initialEventVector=new Vector();
	CompleteTestCaseGenerator(EventGraph eventGraph){
		this.eventGraph=eventGraph;
		eventGraphIndexVector = new Vector[eventGraph.getEGSize()];
		for (int i=0; i< eventGraph.getEGSize();i++){
			eventGraphIndexVector[i]=new Vector();
		}
		for (int i=0; i< eventGraph.getEGSize();i++){
			for (int j=0; j<eventGraph.getEGSize();j++){
				if (eventGraph.getEventGraphStatus(i,j)==EventGraph.VALID ||
eventGraph.getEventGraphStatus(i,j)==EventGraph.TERMINAL){
					eventGraphIndexVector[i].add(new Integer(j));
				}
			}
		}
		for (int i=0; i< eventGraph.getEGSize();i++){
			GUIEvent event = eventGraph.getEvent(i);
			GUIObject eventObject = event.getEventObject();
			if (eventObject !=null && eventObject.getBaseWindow().getPropertyString("RootWindow").equals("true")){
				initialEventVector.add(new Integer(i));
			}
		}
		System.out.println(eventGraphIndexVector[0]==null);
	}
	private int getID(){
		int returnID = testCaseID;
		testCaseID++;
		return returnID;
	}
	public void generateSequential(File directory, int testcaseLength, int testcaseNumber){
		int toGenerate=testcaseNumber;
		Vector stepVector = new Vector();
		for (int i=0; i< eventGraph.getEGSize();i++){
			stepVector.clear();
			stepVector.add(new Integer(i));
			toGenerate =
				generateSequentialWithLevel(directory,testcaseLength-1,stepVector,toGenerate);
		}
		if (toGenerate >0)
			System.out.println("Opps, try to create more than possible");
	}
	private int generateSequentialWithLevel( File testcaseDirectory, 
												int level, 
												Vector currentStepVector,
												int toGenerate){
		File testcaseFile;
		if (toGenerate ==0)
			return 0;
		int previousEventID = ((Integer)currentStepVector.lastElement()).intValue();
		
		if (level <= 0){
			try {
				testcaseFile = new File(testcaseDirectory,getID()+".tst");
				FileWriter writer = new FileWriter(testcaseFile);
				writer.write("<Testcase>\n");
				GUIEvent event;
				GUIObject eventObject,eventWindowResult=null;
				for (int j=0; j<currentStepVector.size();j++){
					System.out.print("Hello"+(Integer)currentStepVector.elementAt(j));
					event = eventGraph.getEvent(((Integer)currentStepVector.elementAt(j)).intValue());
					System.out.println(event==null);
					eventObject=event.getEventObject();
					writer.write(event.stepToStringWithIndentation(eventObject,0,eventWindowResult));
					writer.write("\n");
					
					eventWindowResult = eventObject.getInvokeeObject();
					if (eventWindowResult == null)
						eventWindowResult =eventObject.getBaseWindow();
					
				}
				/*event = eventGraph.getEvent(i);
				 eventObject=event.getEventObject();
				 writer.write(event.stepToStringWithIndentation(eventObject,0,eventWindowResult));*/
				writer.write("</Testcase>\n");
				writer.close();
				toGenerate--;
			} catch (IOException e){
				e.printStackTrace();
			}
			
		}else {
			for (int i=0; i < eventGraphIndexVector[previousEventID].size() && toGenerate >0;i++){
				
				currentStepVector.add(eventGraphIndexVector[previousEventID].elementAt(i));
				System.out.println("Hmm"+eventGraphIndexVector[previousEventID].elementAt(i));
				toGenerate=generateSequentialWithLevel(testcaseDirectory,level-1,currentStepVector,toGenerate);
				currentStepVector.remove(currentStepVector.size()-1);
			}
		}		
		
		return toGenerate;
	}
	public void generateRandom(File directory,int testcaseLength, int testcaseNumber){
		int eventID1, eventID2;
		File testcaseDirectory,testcaseFile;
		GUIEvent event;
		int [] eventIndexSequence = new int[testcaseLength];
		EventSequenceRecord eventSequenceRecord = new EventSequenceRecord();
		
		/*eventGraphWriter eventGraphWriter= new eventGraphWriter(eventGraph);
		 eventGraphWriter.writeFile(new File("TerpWord3.eventGraph"));*/
		Random randomNumberGenerator = new Random();
		if ((directory == null) || directory.isDirectory()== false){
			testcaseDirectory = new File(System.getProperty("user.dir"));
		} else {
			testcaseDirectory = directory;
		}
		try {
			int i = 0;
			while(i< testcaseNumber){
				eventID1 = randomNumberGenerator.nextInt(eventGraph.getEGSize());
				eventIndexSequence[0]=eventID1;
				for (int j=1; j < testcaseLength ; j++) {
					int eventGraphIndexVectorSize=eventGraphIndexVector[eventID1].size();
					System.out.print("Event "+ eventID1);
					System.out.println("Availabe options "+eventGraphIndexVectorSize);
					if (eventGraphIndexVectorSize ==0)
						System.out.println("Problem event "+eventGraph.getEvent(eventID1).toStringWithIndentation(1,null,false));
					int eventGraphEventIndex =randomNumberGenerator.nextInt(eventGraphIndexVector[eventID1].size());
					eventID2=((Integer)eventGraphIndexVector[eventID1].elementAt(eventGraphEventIndex)).intValue();
					eventIndexSequence[j] = eventID2;
					eventID1=eventID2;
				}
				
				if (eventSequenceRecord.isExist(eventIndexSequence) != true) {
					eventSequenceRecord.addEventSequence(eventIndexSequence);

					testcaseFile = new File(testcaseDirectory,getID()+".tst");
					FileWriter writer = new FileWriter(testcaseFile);
					writer.write("<Testcase>\n");
				/*
				System.out.println("EventID "+eventID1);
				event= eventGraph.getEvent(eventID1);
				GUIObject eventObject = event.getEventObject();
				GUIObject eventWindowResult = eventObject.getInvokeeObject();
				if (eventWindowResult == null)
					eventWindowResult = eventObject.getBaseWindow();
				System.out.println(0+"\n"+event.stepToStringWithIndentation(eventObject,0));
				writer.write(event.stepToStringWithIndentation(eventObject,0,null));
				*/
					GUIObject eventObject = null, eventWindowResult = null;
					for (int j=0; j < testcaseLength ; j++) {					
						//System.out.println("EventID "+eventIndexSequence[j]);
						event = eventGraph.getEvent(eventIndexSequence[j]);
						eventObject= event.getEventObject();
						writer.write("\n");
						writer.write(event.stepToStringWithIndentation(eventObject,0,eventWindowResult));
						eventWindowResult = eventObject.getInvokeeObject();
						if (eventWindowResult == null)
							eventWindowResult =eventObject.getBaseWindow();
					}
					writer.write("</Testcase>\n");
					writer.close();
					i++;
				}
			}
		} catch (IOException e){
			e.printStackTrace();
		}
	}
	public void debugInfo(){
		for (int i=0; i < eventGraph.getEGSize();i++){
			if (eventGraphIndexVector[i].size()==0){
				GUIEvent event = eventGraph.getEvent(i);
				GUIObject eventObject=event.getEventObject();
				eventObject.print();
			}
		}
	}
	private static void printUsage() {
		System.out.println("usage: Java CompleteTestCaseGenerator -options\n");
		System.out.println("where options include:");
		System.out.println("\t-r|--random");
		System.out.println("\t-s|--sequential");
		System.out.println("\t-n|--number          <number of test case to generate, 0 for all>");
		System.out.println("\t-l|--length          <length of the test cases>");
		System.out.println("\t-g|--gui             <GUI file to use>");
		System.out.println("\t-e|--eventgraph      <event graph file to use>");
		System.out.println("\t-d|--targetDirectory <place to hold the test cases>");
		System.out.println("\nNote: you have to pick either -r or -s, not both, not neither.");
		System.out.println("    -n, -l -g options are required, -e is optional");
		System.out.println("    -e is optional, if omitted, a new EventGraph will be generated");
		System.out.println("    -d is optional, if omitted, a TC directory under current directory will be used");
		System.exit(2);
	}
	public static void main (String[] argv){
		CmdLineParser cmdLineParser = new CmdLineParser();

		CmdLineParser.Option oRandom = cmdLineParser.addBooleanOption('r',"random");
		CmdLineParser.Option oSequential = cmdLineParser.addBooleanOption('s',"sequential");
		CmdLineParser.Option oNumber = cmdLineParser.addIntegerOption('n',"number");
		CmdLineParser.Option oLength = cmdLineParser.addIntegerOption('l',"length");
		CmdLineParser.Option oGUI = cmdLineParser.addStringOption('g',"gui");
		CmdLineParser.Option oEventgraph = cmdLineParser.addStringOption('e',"eventgraph");
		CmdLineParser.Option oTargetDirectory = cmdLineParser.addStringOption('d',"targetDirectory");


		Integer integerNumber, integerLength;
		String guiFileNameString, eventFileNameString,directoryNameString;

		try {
			cmdLineParser.parse(argv);
		} catch (CmdLineParser.OptionException e){
			printUsage();
		}

		Boolean isRandom, isSequential;
		isRandom = (Boolean)cmdLineParser.getOptionValue(oRandom);
		isSequential = (Boolean)cmdLineParser.getOptionValue(oSequential);

		boolean isEventGraphAvailable = true;

		if (isRandom == null && isSequential == null)
			printUsage();
		else if (isRandom != null && isSequential != null)
			printUsage();

		integerNumber = (Integer)cmdLineParser.getOptionValue(oNumber);
		integerLength = (Integer)cmdLineParser.getOptionValue(oLength);
		guiFileNameString = (String)cmdLineParser.getOptionValue(oGUI);
		if (integerNumber == null || integerLength == null || guiFileNameString == null)
			printUsage();

		eventFileNameString = (String)cmdLineParser.getOptionValue(oEventgraph);
		if (eventFileNameString == null)
			isEventGraphAvailable = false;

		directoryNameString = (String)cmdLineParser.getOptionValue(oTargetDirectory);
		if (directoryNameString == null)
			directoryNameString = System.getProperty("user.dir");


		try {
			
			GUIParser parser = new GUIParser(guiFileNameString, false, null);
			Vector allGUIObject = parser.getGUIObjects();
			EventGraph eventGraph;
			if (isEventGraphAvailable == true) {
				//File eventFile = new File(eventFileNameString);
				EventGraphReader eventGraphReader=new EventGraphReader(eventFileNameString,allGUIObject);
				if (eventGraphReader.isSuccess()) {
					eventGraph = eventGraphReader.getEventGraph();
				} else {
					System.out.println("Invalid event graph file, please check");
					return;
				}
			}
			else {
				EIG eig = new EIG();
				eig.generateEG(allGUIObject);
				eventGraph = eig.getEventGraph();
			}
			CompleteTestCaseGenerator testCaseGenerator = new CompleteTestCaseGenerator(eventGraph);
			testCaseGenerator.debugInfo();
			File testcaseDirectory = new File(directoryNameString);
			File directory = new File(testcaseDirectory,"TC");
			if (directory.exists())
				if (!directory.isDirectory()){
					directory.delete();
					directory.mkdir();
				} else {
				}
			else{
				directory.mkdir();
			}
			if (isRandom != null)
				testCaseGenerator.generateRandom(directory,
                                        integerLength.intValue(),
                                        integerNumber.intValue());
			else 
				testCaseGenerator.generateSequential(
																				directory,
                                       	integerLength.intValue(),
                                       	integerNumber.intValue());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
