public class DebugStack {
	final static int MAXSIZE = 100;
	final static int ERROR_LEVEL = 4;
	String debugInfoString[];
	int currentMessageCount = -1;
	String debugMessagesByLevel[];
	DebugStack () {
		debugInfoString = new String[MAXSIZE];
		for (int i = 0; i < MAXSIZE; i++) {
			debugInfoString[i]=null;
		}
		debugMessagesByLevel = new String[ERROR_LEVEL];
		for (int i=0; i<ERROR_LEVEL; i++) {
			debugMessagesByLevel[i]=null;
		}
	}
	public void cleanStack(){
		for (int i = 0; i < MAXSIZE; i++) {
			debugInfoString[i]=null;
		}
		currentMessageCount = -1;
	}
	private void storeMessage(int iErrorLevel) {
		int iErrorIndex = iErrorLevel + ERROR_LEVEL;
		debugMessagesByLevel[iErrorIndex] = generateMessage();
	} 
	public boolean assignMessage(int messageCount, String message) {
		return assignMessage(messageCount,message,0);
	}
	public boolean assignMessage(int messageCount, String message,int iErrorLevel) {
		if (messageCount >= MAXSIZE) return false;
		
		for (int i=messageCount+1; i<=currentMessageCount; i++) {
			debugInfoString[i]=null;
		}
		debugInfoString[messageCount] = message;
		currentMessageCount=messageCount;
		if (iErrorLevel < 0)
			storeMessage(iErrorLevel);
		return true;	
	}
	public void printMessage() {
		int i = 0;
		while ( i < ERROR_LEVEL && debugMessagesByLevel[i] == null) i++;
		if (i < ERROR_LEVEL) 
			System.out.println(debugMessagesByLevel[i]);
		else
			System.out.println("");
	}
	public String generateMessage() {
		String debugMessage = "";
		for (int i=0; i<= currentMessageCount; i++ ) {
			debugMessage += debugInfoString[i]+",";
		}
		return debugMessage;
	}
}