import java.io.File;
import java.util.Vector;

/*
 * Created on Apr 22, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Bin
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class EFG implements EventGraphGenerator{
	
	//Vector eventVector;
	//int [][] eventGraph;
	//boolean isValid = false;
	EventGraph eventGraph;
	
	EFG(){
		eventGraph = new EventGraph();
	}
	public EventGraph getEventGraph(){ return eventGraph;}
	
	public void generateEG(Vector GUIObjects){
		for (int i =0; i < GUIObjects.size(); i++){
			GUIObject guiObject = (GUIObject) GUIObjects.elementAt(i);
			Vector replayActionVector = (Vector)guiObject.getProperty("ReplayableAction");
			if (replayActionVector != null ){
				for (int j=0; j< replayActionVector.size();j++){
					GUIEvent event = new GUIEvent(guiObject);
					event.setEvent((String) replayActionVector.elementAt(j));
					eventGraph.addEvent(event);
				}
			}
		}
		//create and initialize event graph
		int iTotalReplayActions = eventGraph.getEGSize();
		//eventGraph = new int[iTotalReplayActions][iTotalReplayActions];
		eventGraph.rebuildEventGraph();
		Vector eventVector = eventGraph.getEventVector();
		for (int i =0; i < iTotalReplayActions; i++){
			for (int j=0; j< iTotalReplayActions; j++){
				GUIEvent eventOne = (GUIEvent) eventVector.elementAt(i);
				GUIEvent eventTwo = (GUIEvent) eventVector.elementAt(j);
				boolean isFollowable = isEventFollowableForEFG(eventOne,eventTwo);
				if (isFollowable){
					String type = eventOne.getEventObject().getPropertyString("Type");
					if (type != null && type.equals("TERMINAL"))
						eventGraph.setEventGraphStatus(i,j,EventGraph.TERMINAL);
					else
						eventGraph.setEventGraphStatus(i,j,EventGraph.VALID);
					
					
					GUIObject guiObjectOne = eventOne.getEventObject();
					GUIObject guiObjectTwo = eventTwo.getEventObject();
					guiObjectOne.addOutgoing(guiObjectTwo);
					guiObjectTwo.addIncoming(guiObjectOne);
				}
				else{
					eventGraph.setEventGraphStatus(i,j,EventGraph.INVALID);
				}
			}
		}
		eventGraph.setValid(true);
	}
	
	private boolean isEventFollowableForEFG(GUIEvent eventOne, GUIEvent eventTwo){
		if (eventOne == null || eventTwo == null)
			return false;
		/*
		 * handling special case for JMenuItem and JMenu
		 */
		GUIObject afterEventOneGUIObject=eventOne.getEventObject().getInvokeeObject();
		/*GUIObject eventObjectOne=eventOne.getEventObject();
		GUIObject eventObjectTwo=eventTwo.getEventObject();
		if (eventObjectTwo.getPropertyString("Class").equals("javax.swing.JMenuItem") ||
				eventObjectTwo.getPropertyString("Class").equals("javax.swing.JMenu")){
			if (eventObjectTwo.getParent()==eventObjectOne)
				return true;
			else
				return false;
		}*/
		
		GUIObject baseWindowAfterEventOne,baseWindowTwo;
		if (eventOne.getEventObject().getPropertyString("Class").equals("javax.swing.JMenuItem")){
			GUIObject eventObjectAfterEventOne= eventOne.getEventObject().getInvokeeObject();
			if (eventObjectAfterEventOne == null)
				baseWindowAfterEventOne = eventOne.getEventObject().getWindow().getBaseWindow();
			else
				baseWindowAfterEventOne = eventObjectAfterEventOne.getBaseWindow();
		}else if (eventOne.getEventObject().getPropertyString("Type").equals("TERMINAL"))
			baseWindowAfterEventOne = eventOne.getWindow().getInvokerObject().getWindow();
		else 	
			baseWindowAfterEventOne = eventOne.getWindow().getBaseWindow();
		
		baseWindowTwo = eventTwo.getWindow().getBaseWindow();
		
		if (baseWindowAfterEventOne == baseWindowTwo){
			return true;
		} else if (baseWindowAfterEventOne.getPropertyString("Rootwindow").equals("true") &&
				baseWindowTwo.getPropertyString("Rootwindow").equals("true")){
			/*
			 * handle multiple root window
			 */
			return true;
		} else 
			return false;
	}
	public static void printUsage() {
		System.out.println("usage: Java EIG -options\n");
		System.out.println("where options include:");
		System.out.println("\t-g|--gui  <input gui file>");
		System.out.println("\t-e|--eventgraph  <output efg file>");
		System.out.println("\nNote: -g is required,");
		System.out.println("      -e is option, if omitted, the output filename is the same with gui file, but with .EFG suffix");
		System.exit(2);
	}
	
	public static void main(String [] args){
		CmdLineParser cmdLineParser = new CmdLineParser();

		CmdLineParser.Option oGUI = cmdLineParser.addStringOption('g',"gui");
		CmdLineParser.Option oEventGraph = cmdLineParser.addStringOption('e',"eventgraoh");
		
		String guiFileNameString, eventFileNameString;

		try {
			cmdLineParser.parse(args);
		} catch (CmdLineParser.OptionException e){
			printUsage();
		}
		
		guiFileNameString = (String)cmdLineParser.getOptionValue(oGUI);
		if (guiFileNameString == null || guiFileNameString.equals(""))
			printUsage();

		eventFileNameString = (String)cmdLineParser.getOptionValue(oEventGraph);
		if (eventFileNameString == null){
			int index = guiFileNameString.lastIndexOf('.');
			if (index < 0)
				eventFileNameString = guiFileNameString+".EFG";
			else 
				eventFileNameString = guiFileNameString.substring(0,index)+".EFG";
		}
		
		try {
			
			//GUIParser parser = new GUIParser("TerpWord3gui", false, new URL("http://www.cs.umd.edu/~bingan/req7/"));
			GUIParser parser = new GUIParser(guiFileNameString, false, null);
			EFG eig = new EFG();
			Vector allGUIObject = parser.getGUIObjects();
			eig.generateEG(allGUIObject);
			EventGraph eventGraph= eig.getEventGraph();
			
			EventGraphWriter eventGraphWriter= new EventGraphWriter(eventGraph);
			eventGraphWriter.writeFile(new File(eventFileNameString));
		} catch (Exception e) {
		}
	}
}
