import java.io.*;
import java.util.*;
import java.net.*;

public class EFGParser {
	
	private boolean valid=true;
	private String source;
	private URL url;
	
    EFGParser(HashMap allGUIObject,String filename,URL urlIn){

	try {
		source = filename;
		url = new URL(urlIn,filename);
	    org.jdom.input.SAXBuilder builder = new org.jdom.input.SAXBuilder();
	    org.jdom.Document doc = builder.build(url);
	    org.jdom.Element root = doc.getRootElement();
	    List guiEFGs = root.getChildren("GUIEFG");
	    List entries,rows;
		org.jdom.Element guiEFG,row,efgEntry;
		String entry;
	    Vector guiEFGList=new Vector();
	    GUIObject sourceObject,destObject;

	    //System.out.println("No. of GUIEFG: "+guiEFGs.size());

	    for(int i=0;i<guiEFGs.size();i++) {
			guiEFG = (org.jdom.Element) guiEFGs.get(i);
			rows = guiEFG.getChildren("Row");
			//System.out.println("Rows: " +rows.size());
			guiEFGList.removeAllElements();
			
			for ( int j=0;j< rows.size();j++) {
				row = (org.jdom.Element) rows.get(j);
				source= row.getChildText("Name");
				//System.out.println("Items: "+source);
				//System.out.println(row);
				//System.out.println(row.getChildren().size());
				guiEFGList.addElement(source);
			}
			for (int j=0; j< rows.size();j++){
				row = (org.jdom.Element) rows.get(j);
				entries = row.getChildren("Entry");
				//System.out.print(entries.size()+":");
				for (int k=0;k<entries.size();k++){
					//System.out.println("crap");
					efgEntry=(org.jdom.Element) entries.get(k);
					if (efgEntry == null)
						System.out.println("Error: Cannot get EFG entry");
					else {
						//System.out.println("shit");
						entry = efgEntry.getValue();
						if (entry == null){
							System.out.println("Entry is null");
						} else {
							//System.out.println("Entry is not null: "+entry);
							if (entry.equals("1")){
								//System.out.print("X");
								sourceObject=(GUIObject)allGUIObject.get(guiEFGList.elementAt(j));
								destObject=(GUIObject)allGUIObject.get(guiEFGList.elementAt(k));
								if ((sourceObject != null) &&
									(destObject != null)){
									sourceObject.addOutgoing(destObject);
									destObject.addIncoming(sourceObject);
								}
							} else {
								//System.out.print("O");
							}
						
						}
					}
				}
				//System.out.println("|");
			}
	    }
	    valid = true;
	}
	catch (FileNotFoundException e){
		valid = false;
	}
	catch (Exception e) {
		System.out.println("Error: "+ e);
	}
    }
    
    public boolean isValid(){
    	return valid;
    }

    public static void main(String args[]) {
    	HashMap map=new HashMap();
    	try {
			EFGParser efgParser=new EFGParser(map,"TerpWord.EFG",new URL("http://www.cs.umd.edu/~bingan/req7/"));
    	} catch (MalformedURLException e){}
    }
}
