import java.util.Vector;

/*
 * Created on Jun 7, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author bingan
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class EventGraph {
	final static int EMPTY=-1;
	final static int INVALID = 0;
	final static int VALID = 1;
	final static int TERMINAL = 2;
	
	Vector eventVector;
	int [][] eventGraph;
	int eventGraphSize=0;
	boolean isValid = false;
	
	EventGraph(){
		eventVector = new Vector();
	}
	
	public void addEvent(GUIEvent event){
		if (event != null){
			eventVector.addElement(event);
		}
	}
	public boolean rebuildEventGraph(){
		if (eventVector == null){
			System.out.println("EventGraph: null eventVector");
			return false;
		}
		int newEventGraphSize = eventVector.size();
		if (newEventGraphSize ==0){
			System.out.println("EventGraph: new size is zero");
			return false;
		}
		if (newEventGraphSize < eventGraphSize){
			System.out.println("EventGraph: don't know how to handle reduced event graph");
			return false;
		}
		
		int newEventGraph[][] = new int[newEventGraphSize][newEventGraphSize];
		for (int i=0;i< newEventGraphSize;i++){
			for (int j=0;j<newEventGraphSize;j++){
				if (i<eventGraphSize && j< eventGraphSize){
					newEventGraph[i][j]=eventGraph[i][j];
				} else {
					newEventGraph[i][j]=EMPTY;
				}
			}
		}
		eventGraph = newEventGraph;
		eventGraphSize = newEventGraphSize;
		return true;
	}
	public boolean reduceEventAt(int eventID){
		if (eventID< 0 || eventID>=eventGraphSize)
			return false;
		if (eventVector == null)
			return false;
		if (eventGraph == null)
			return false;
		if (isValid == false)
			return false;
		// assume the current event graph are valid
		int newEventGraphSize = eventGraphSize -1;
		int newEventGraph[][] = new int[newEventGraphSize][newEventGraphSize];
		int newRowIndex, newColIndex;
		for (int i=0;i< eventGraphSize; i++){
			for (int j=0; j< eventGraphSize; j++){
				if (i<eventID)
					newRowIndex = i;
				else if (i>eventID)
					newRowIndex = i - 1;
				else
					newRowIndex = -1;
				
				if (j<eventID)
					newColIndex = j;
				else if (j>eventID)
					newColIndex = j - 1;
				else
					newColIndex = -1;
				if (newRowIndex != -1 && newColIndex != -1)
					newEventGraph[newRowIndex][newColIndex]= eventGraph[i][j];
			}
		}
		eventGraphSize --;
		eventGraph = newEventGraph;
		return true;
	}
	
	public Vector getEventVector(){return eventVector;}
	public int[][] getEventGraph(){return eventGraph;}
	public boolean isValid() { return isValid;}
	public int getEGSize() {
		if (eventVector==null){
			return EMPTY;
		} else {
			return eventVector.size();
		}
	}
	
	public GUIEvent getEvent(int eventID){
		if (eventVector == null)
			return null;
		if (eventID < eventVector.size() && eventID >= 0){
			return (GUIEvent)eventVector.elementAt(eventID);
		}
		//System.out.println("Events Size "+eventVector.size());
		return null;
	}
	public int getEventGraphStatus(int eventID1,int eventID2){
		if (eventVector == null) return EMPTY;
		if (eventID1<0 || eventID1>= eventVector.size() || eventID2<0 || eventID2>=eventVector.size())
			return EMPTY;
		return eventGraph[eventID1][eventID2];
	}
	
	
	public boolean setEventGraphStatus(int eventID1, int eventID2, int status){
		if (eventVector == null) return false;
		if (eventID1<0 || eventID1>= eventVector.size() || eventID2<0 || eventID2>=eventVector.size())
			return false;
		eventGraph[eventID1][eventID2]=status;
		return true;
	}
	
	public void setValid(boolean isValid){this.isValid = isValid;}
	

}
