import java.io.File;
import java.util.List;
import java.util.Vector;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

/*
 * Created on Apr 27, 2005
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
import java.util.HashMap;
import java.net.URL;
import java.io.InputStream;
/**
 * @author bingan
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class EventGraphReader {
	/*
	 * vector of vectors
	 * inner vector is the representation of steps for a event
	 */
	EventGraph eventGraph;
	boolean isSuccess;
	EventGraphReader(String efgFilename,Vector allGUIObjects) {
		this(efgFilename, allGUIObjects, null);
	}
	EventGraphReader(String efgFilename,Vector allGUIObjects,URL urlLocation){
		eventGraph = new EventGraph();
		HashMap eventLookupMap = new HashMap();
		
		if (efgFilename != null){
			eventGraph = new EventGraph();
			/* build eventLookupMap */
			for (int i=0; i< allGUIObjects.size(); i++){
				GUIObject guiObject = (GUIObject) allGUIObjects.elementAt(i);
				//TODO might need to check if window is null
				GUIObject windowObject = guiObject.getWindow();
				if (windowObject == null) {
					//guiObject.print();
				}else {
					String windowNameString = guiObject.getWindow().getPropertyString("Title");
					String guiObjectNameString = guiObject.getPropertyString("Title");
					eventLookupMap.put(windowNameString+guiObjectNameString,guiObject);
				}
			}
			try {
				SAXBuilder builder= new SAXBuilder();
				Document doc;
				if (urlLocation != null){
					URL urlEFGFile = new URL(urlLocation,efgFilename);
					InputStream in = urlEFGFile.openStream();
					doc = builder.build(in);
				} else {
					doc = builder.build(new File(efgFilename));
				}
				Element root = doc.getRootElement();
				
				//Element events = root.getChild("Events");
				List eventList = root.getChild("Events").getChildren("Event");
				int eventVectorSize = eventList.size();
				/* rebuild events */
				for (int i=0; i < eventVectorSize; i++){
					Element event = (Element)eventList.get(i);
					String windowNameString = event.getChildText("Window");
					String guiObjectNameString = event.getChildText("Component");
					String actionString = event.getChildText("Action");
					GUIObject guiObject = (GUIObject)eventLookupMap.get(windowNameString+guiObjectNameString);
					GUIEvent guiEvent = new GUIEvent(guiObject,actionString);
					eventGraph.addEvent(guiEvent);
				}
				eventGraph.rebuildEventGraph();
				/* read in the 0 and 1's from event matrix */
				List eventGraphRows= root.getChild("EventGraph").getChildren("Row");
				if (eventVectorSize != eventGraphRows.size()){
					System.out.println("EventGraphReader: mismatch between events and rows");
					isSuccess=false;
					return;
				}
				for(int i=0 ; i< eventVectorSize; i++){
					Element row = (Element) eventGraphRows.get(i);
					List colValues = row.getChildren("E");
					if (eventVectorSize != eventGraphRows.size()){
						System.out.println("EventGraphReader: mismatch between events and columns at row "+ i);
						isSuccess=false;
						return;
					}
					GUIObject guiobject1 = eventGraph.getEvent(i).getEventObject();
					for (int j=0; j< eventVectorSize;j++){
						Element matrixCell = (Element) colValues.get(j);
						String matrixCellValue = matrixCell.getText();
						GUIObject guiobject2 = eventGraph.getEvent(j).getEventObject();
						if ("0".equals(matrixCellValue)){
							eventGraph.setEventGraphStatus(i,j,EventGraph.INVALID);
						}else if ("1".equals(matrixCellValue)){
							eventGraph.setEventGraphStatus(i,j,EventGraph.VALID);
							guiobject1.addOutgoing(guiobject2);
							guiobject2.addIncoming(guiobject1);
						}else if ("2".equals(matrixCellValue)){
							eventGraph.setEventGraphStatus(i,j,EventGraph.TERMINAL);
							guiobject1.addOutgoing(guiobject2);
							guiobject2.addIncoming(guiobject1);
						} else {
							System.out.print("EventGraphReader: unknown value at eventGraph ");
							System.out.println("at row "+i+" col "+j);
							isSuccess = false;
							return;
						}
					}
				}
				isSuccess=true;
			} catch (Exception e){
				e.printStackTrace();
				isSuccess=false;
			} 	
			if (isSuccess== true) 
				eventGraph.setValid(true);
		}
	}
	public boolean isSuccess() {return isSuccess;}
	public EventGraph getEventGraph() {
		if (isSuccess)
			return eventGraph;
		else
			return null;
	}
	
	
}
