/*
 * Created on May 7, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
import java.awt.Image;
import java.awt.Toolkit;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;
import java.io.File;

/**
 * @author Bin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class GUIObject {
	final static int WINDOW=0;
	final static int CONTAINER=1;
	final static int LEAF=2;
	int finalX,finalY;
	int xParent, yParent;
	int x,y,xOffset,yOffset;
	String type;
	HashMap properties = new HashMap();
	GUIObject parent;
	Vector children;
	Vector invokesList;
	GUIObject guiWindow=null;
	GUIObject invokerObject=null,invokeeObject=null;
	boolean isEFGEnabled=false;
	/*
	 * base window defined as the closest modal or root window
	 */
	GUIObject baseWindow = null;
	Vector incomingEFG;
	Vector outgoingEFG;
	/*
	 * these are for scaling the images
	 */
	Image originalImage,scaledImage;
	int scale;
	

	GUIObject (String typeIn) {
		x=-1;
		y=-1;
		xOffset=-1;
		yOffset=-1;
		type=typeIn;
		children=new Vector();
		invokesList=new Vector();
		incomingEFG=new Vector();
		outgoingEFG=new Vector();
		scale = 1;
	}
	
	public String replace(String s, String f, String r){
		if (s == null) return s;
		if (f == null) return s;
		if (r == null) r = "";
		
		int index = s.indexOf(f);
		while (index != -1){
			s=s.substring(0,index)+r+s.substring(index+f.length());
			index += r.length();
			index = s.indexOf(f,index);
		}
		return s;
	}
	/*
	 * should be changed to read from the GUI file
	 */
	public void setImage(String imageDirectory, URL url){
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		URL imageURL;
		try {
			String titleString ="";
			Vector titleValueVector = (Vector)properties.get("JPEG");
			/*
			 * only use the first image if multiple exists
			 */
			if (titleValueVector.size()>=1){
				String imageFilename=(String) titleValueVector.elementAt(0);
				/*imageFilename=replace(imageFilename," ","_");
				imageFilename=replace(imageFilename,"/","_");
				if (url.toString().startsWith("http://")){
					imageFilename=imagePath +"/"+imageFilename+".JPG";
				} else {
					imageFilename=imagePath +File.separator+imageFilename+".JPG";
				}*/
				if (url != null) {
					imageURL = new URL(url,imageFilename);
					//System.out.println("BBBGGG:GUIObject:setImage:"+imageURL);
					originalImage = toolkit.getImage(imageURL);		
				} else {
					originalImage = toolkit.getImage(imageDirectory+File.separator+imageFilename);
				}
				scaledImage = originalImage;
			}
		} catch (MalformedURLException e){
			System.out.println("Error:GUIObject:setImage:"+e);
		}
	}
	
	public Image scaleImage(int newScale,int scaleBase){
		if (originalImage==null)
			return null;
		if (newScale == 1){
			return originalImage;
		}
		
		if (scale != newScale){
			scale = newScale;
			scaledImage = originalImage.getScaledInstance(xOffset*scaleBase/scale,
												yOffset*scaleBase/scale,
												Image.SCALE_DEFAULT);
		}
		return scaledImage;
	}
	public void print(){
		GUIObject temp;
		if (type.equals("Menu")){
			System.out.println("Menu");
			System.out.println("\tName: "+ getProperty("Title"));
			System.out.println("\tParent: "+parent.getProperty("Title"));
			System.out.println("\tChildren: ");
			for (int i=0; i<children.size();i++){
				temp=(GUIObject)children.elementAt(i);
				System.out.println("\t\t"+temp.getType()+":"+temp.getProperty("Title"));
			}
		} else if (type.equals("GUI")){
			System.out.println("GUI");
			System.out.println("\tName: "+ getProperty("Title"));
			System.out.println("\tWidth: "+ xOffset);
			System.out.println("\tHeight: "+ yOffset);
			System.out.println("\tChildren: ");
			for (int i=0; i<children.size();i++){
				temp=(GUIObject)children.elementAt(i);
				System.out.println("\t\t"+temp.getType()+":"+temp.getProperty("Title"));
			}
		} else if (type.equals("Component")){
			System.out.println("Component");
			System.out.println("\tName: "+ getProperty("Title"));
			System.out.println("\tWidth: "+ xOffset);
			System.out.println("\tHeight: "+ yOffset);
			System.out.println("\tX: "+ x);
			System.out.println("\tY: "+ y);
			System.out.println("\tParent: "+parent.getProperty("Title"));
			System.out.println("\tChildren: ");
			for (int i=0; i<children.size();i++){
				temp=(GUIObject)children.elementAt(i);
				System.out.println("\t\t"+temp.getType()+":"+temp.getProperty("Title"));
			}
			System.out.println("\tinvokesList: ");
			for (int i=0; i<invokesList.size();i++){
				System.out.println("\t\t"+(String)invokesList.elementAt(i));
			}
		} else if (type.equals("Container")){
			System.out.println("Container");
			System.out.println("\tName:"+getProperty("Title"));
			System.out.println("\tWidth: "+ xOffset);
			System.out.println("\tHeight: "+ yOffset);
			System.out.println("\tX: "+ x);
			System.out.println("\tY: "+ y);
			System.out.println("\tParent: "+parent.getProperty("Title"));
			System.out.println("\tChildren: ");
			for (int i=0; i<children.size();i++){
				temp=(GUIObject)children.elementAt(i);
				System.out.println("\t\t"+temp.getType()+":"+temp.getProperty("Title"));
			}
			Object invokeList = getProperty("Invokelist");
			if (invokeList != null){
				System.out.println("\tinvokesList: ");
				if (invokeList instanceof String){
					System.out.println("\t\t"+(String)invokeList);
				} else if (invokeList instanceof Vector){
					Vector invokeVector = (Vector) invokeList;
					for (int i=0; i < invokeVector.size();i++)
						System.out.println("\t\t"+(String)invokeVector.elementAt(i));
				}
			}
		} else if (type.equals("Widget")){
			System.out.println("Widget");
			System.out.println("\tName:"+getProperty("Title"));
			System.out.println("\tWidth: "+ xOffset);
			System.out.println("\tHeight: "+ yOffset);
			System.out.println("\tX: "+ x);
			System.out.println("\tY: "+ y);
			System.out.println("\tParent: "+parent.getProperty("Title"));
			if (children.size()>0){
				System.out.println("\tChildren: ");
				for (int i=0; i<children.size();i++){
					temp=(GUIObject)children.elementAt(i);
					System.out.println("\t\t"+temp.getType()+":"+temp.getProperty("Title"));
				}
			}
			Vector invokeVector = getProperty("Invokelist");
			if (invokeVector != null){
				System.out.println("\tinvokesList: ");				
				for (int i=0; i < invokeVector.size();i++)
					System.out.println("\t\t"+(String)invokeVector.elementAt(i));
			}
		} else {
			System.out.println("No such type: " + type);
		}
	}
	
	public HashMap getHashedProperties(){
		return properties;
	}
	
	public String[][] getProperties(){
		/*
		 * Output in X by 2 table format
		 */
			String columnData[][]= null;
			String propertyName,propertyValue;
			GUIObject temp;
			if (type.equals("Menu")){
				System.out.println("Menu");
				System.out.println("\tName: "+ getProperty("Title"));
				System.out.println("\tParent: "+parent.getProperty("Title"));
				System.out.println("\tChildren: ");
				for (int i=0; i<children.size();i++){
					temp=(GUIObject)children.elementAt(i);
					System.out.println("\t\t"+temp.getType()+":"+temp.getProperty("Title"));
				}
			} else if (type.equals("GUI")){
				columnData = new String[properties.size()+2][2];
				
				/*
				 * set the title on the first line
				 */
				columnData[0][0]="Title";
				columnData[0][1]=(String) properties.get("Title");
				
				
				Iterator iter = properties.keySet().iterator();
				int i=1;
				while (iter.hasNext() == true){
					propertyName = (String) iter.next();
					/*
					 * We don't want to see title for the second time
					 */
					if (!propertyName.equals("Title")){
						columnData[i][0]=propertyName;
						columnData[i][1]=(String) properties.get(propertyName);
						i++;					
					}
					
				}
				
				columnData[i][0]="Width";
				columnData[i][1]= "" + xOffset;
				
				columnData[i+1][0]="Height";
				columnData[i+1][1]=""+yOffset;
				
			} else if (type.equals("Component")){
				System.out.println("Component");
				System.out.println("\tName: "+ getProperty("Title"));
				System.out.println("\tWidth: "+ xOffset);
				System.out.println("\tHeight: "+ yOffset);
				System.out.println("\tX: "+ x);
				System.out.println("\tY: "+ y);
				System.out.println("\tParent: "+parent.getProperty("Title"));
				System.out.println("\tChildren: ");
				for (int i=0; i<children.size();i++){
					temp=(GUIObject)children.elementAt(i);
					System.out.println("\t\t"+temp.getType()+":"+temp.getProperty("Title"));
				}
				System.out.println("\tinvokesList: ");
				for (int i=0; i<invokesList.size();i++){
					System.out.println("\t\t"+(String)invokesList.elementAt(i));
				}
			} else {
				System.out.println("No such type: " + type);
			}
			return columnData;
		}
	public void addChild(GUIObject child){
		children.addElement(child);
	}
	public void setXParent(int xParentIn){
		xParent=xParentIn;
	}
	public void setYParent(int yParentIn){
		yParent=yParentIn;
	}
	public void setX(int xIn){
		x=xIn;
	}
	public void setY(int yIn){
		y=yIn;
	}
	public void setXOffset(int xIn){
		xOffset=xIn;
	}
	public void setYOffset(int yIn){
		yOffset=yIn;
	}
	public void setParent(GUIObject guiObject ){
		parent=guiObject;
	}
	public void setProperty(String propertyName, Object propertyValue){
		properties.put(propertyName,propertyValue);
	}
	public void addInvoke(String invoke){
		invokesList.addElement(invoke);
	}

	public GUIObject getParent(){
		return parent;
	}

	public int getXParent(){
		return xParent;
	}
	public int getYParent(){
		return yParent;
	}
	public int getX(){
		return x;
	}
	public int getY(){
		return y;
	}
	public int getXOffset(){
		return xOffset;
	}
	public int getYOffset(){
		return yOffset;
	}

	public int getXCenter(){
		return xParent+(x+xOffset)/2;
	}
	public int getYCenter(){
		return yParent+(y+yOffset)/2;
	}
	public String getType(){
		return type;
	}
	public Vector getProperty(String propertyName){
		return (Vector) properties.get(propertyName);
	}
	public String getPropertyString(String propertyName){
		Vector propertyValueVector = (Vector) properties.get(propertyName);
		String propertyValueString = "";
		if (propertyValueVector != null ){
			for (int i=0; i<propertyValueVector.size();i++){
				propertyValueString+=(String)propertyValueVector.elementAt(i);
			}
		}
		return propertyValueString;
	}
	public Vector getChildren(){
		return children;
	}
	public Vector getInvokeList(){
		return invokesList;
	}
	//get and set final postion
	public void setFinal(int xIn, int yIn){
		finalX=xIn;
		finalY=yIn;
	}
	public void setFinalX(int xIn){
		finalX=xIn;
	}
	public void setFinalY(int yIn){
		finalY=yIn;
	}
	public int getFinalX(){
		return finalX;
	}
	public int getFinalY(){
		return finalY;
	}
	
	public void setWindow(GUIObject window){
		guiWindow = window;
	}
	public GUIObject getWindow(){
		return guiWindow;
	}
	public void setBaseWindow(GUIObject window){
		baseWindow=window;
	}
	public GUIObject getBaseWindow(){
		return baseWindow;
	}

	public void addIncoming(GUIObject source){
		incomingEFG.addElement(source);
	}
	public void addOutgoing(GUIObject destination){
		outgoingEFG.addElement(destination);
	}
	public Vector getIncomingEFG(){
		return incomingEFG;
	}
	public Vector getOutgoingEFG(){
		return outgoingEFG;
	}
	public GUIObject getInvokerObject(){
		if (getType().equals("GUI")){
			return invokerObject;
		} else return null;
	}
	public void setInvokerObject(GUIObject guiObject){
		invokerObject=guiObject;
	}
	public GUIObject getInvokeeObject(){
		
			return invokeeObject;
	}
	public void setInvokeeObject(GUIObject guiObject){
		invokeeObject=guiObject;
	}
	public void setEFGEnabled(boolean isEnable){
		isEFGEnabled = isEnable;
	}
	public boolean isEFGEnabled(){ return isEFGEnabled;}
	
}
