import java.io.File;
import java.io.InputStream;
import java.net.URL;
import java.util.HashMap;
import java.util.List;
import java.util.Vector;

import org.jdom.Element;

/*
 * Created on Jun 17, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author bingan
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class GUIParser {
	private String source;
	private URL url;
	Vector allGUIObject;
	private HashMap invokeMap;
	int uniqueCounter=0;
	boolean isAbsoluteCoordinates;
	boolean isValid= false;
	GUIParser(String filename,boolean isAbsolute,URL urlIn){
		allGUIObject = new Vector();
		invokeMap = new HashMap();
		source = filename;
		isAbsoluteCoordinates = isAbsolute;
		
		GUIObject current;
		InputStream in;
		
		
		try {
			org.jdom.input.SAXBuilder builder = new org.jdom.input.SAXBuilder();
			org.jdom.Document doc;
			if (urlIn != null){
				url = new URL(urlIn,filename);
				in = url.openStream();
				doc = builder.build(in);
			} else {
				doc = builder.build(new File(filename));
			}
			
			
			org.jdom.Element root = doc.getRootElement();
			/* get the GUIs */
			List guis = root.getChildren("GUI");
			org.jdom.Element guiUnit,property;
			List menus,components,properties;
			String propertyName,propertyValue;
			int width=0,height=0,x=0,y=0;
			Vector children;
			GUIObject child;
			
			for (int i = 0; i< guis.size();i++){
				guiUnit = (org.jdom.Element) guis.get(i);
				
				current=new GUIObject("GUI");
				
				properties = guiUnit.getChild("Window").getChild("Attributes").getChildren("Property");
				for (int j=0; j< properties.size();j++){
					property = (org.jdom.Element) properties.get(j);
					//System.out.print("BBBGGG: "+property.getChildText("Name"));
					//System.out.println(" "+property.getChildText("Value"));
					propertyName = property.getChildText("Name");
					List propertyValueList = property.getChildren("Value");
					
					if (propertyName.equals("Width")) {
						width = Integer.parseInt(((Element) propertyValueList.get(0)).getValue());
					} else if (propertyName.equals("Height")) {
						height = Integer.parseInt(((Element) propertyValueList.get(0)).getValue());
					} else if (propertyName.equals("X")) {
						x = Integer.parseInt(((Element) propertyValueList.get(0)).getValue());
					} else if (propertyName.equals("Y")) {
						y = Integer.parseInt(((Element) propertyValueList.get(0)).getValue());		
					} else {
						Vector propertyValueVector = new Vector();
						for (int k=0; k< propertyValueList.size();k++){
							propertyValue = ((Element)propertyValueList.get(k)).getValue();
							propertyValueVector.add(propertyValue);
						}
						current.setProperty(propertyName,propertyValueVector);
					}					
				}
				//title = guiUnit.getChildText("Title");
				//current.setProperty("Title",title);
				
				current.setX(0);
				current.setY(0);
				current.setXOffset(width);
				current.setYOffset(height);
				allGUIObject.add(current);
				
				List containers = guiUnit.getChildren("Container");
				for (int j=0; j<containers.size();j++){
					child = parseContainer((org.jdom.Element) containers.get(j),current,current);
					current.addChild(child);
				}
			}
			// set the invoked lists
			for (int i =0; i < allGUIObject.size();i++){
				current=(GUIObject) allGUIObject.elementAt(i);
				if (current.getType().equals("GUI")){
					String guiTitle = current.getPropertyString("Title");
					GUIObject invokingObject = (GUIObject) invokeMap.get(guiTitle);
					if (invokingObject != null){
						current.setInvokerObject(invokingObject);
						invokingObject.setInvokeeObject(current);
						/*System.out.print(invokingObject.getPropertyString("Title"));
						System.out.println(":"+guiTitle);*/
					}
				}
			}
			/* 
			 * set the base window
			 * base window is defined as the closest root window or
			 * modal window for the invokelist tree
			 */
			for (int i=0; i< allGUIObject.size();i++){
				current=(GUIObject) allGUIObject.elementAt(i);
				current.setBaseWindow(findEFGBaseWindow(current));
			}
			isValid=true;
			
		} catch (Exception e){
			System.out.println("Error:GUIParser"+e);
			e.printStackTrace();
		}
	}
	private GUIObject parseContainer(org.jdom.Element container,GUIObject parent,GUIObject window){
		GUIObject current = new GUIObject("Container");
		String title,str;
		int x=0, y=0, width=0, height=0;
		int intValue;
		org.jdom.Element property;
		String propertyName,propertyValue;
		
		current.setParent(parent);
		current.setWindow(window);
		
		List propertyList = container.getChild("Attributes").getChildren("Property");		
		
		for (int i=0; i< propertyList.size();i++){
			property = (org.jdom.Element) propertyList.get(i);
			//System.out.println("BBBGGG"+property.getName());
			propertyName = property.getChildText("Name");
			List propertyValueList = property.getChildren("Value");
			
			if (propertyName.equals("Width")) {
				width = Integer.parseInt(((Element) propertyValueList.get(0)).getValue());
			} else if (propertyName.equals("Height")) {
				height = Integer.parseInt(((Element) propertyValueList.get(0)).getValue());
			} else if (propertyName.equals("X")) {
				x = Integer.parseInt(((Element) propertyValueList.get(0)).getValue());
			} else if (propertyName.equals("Y")) {
				y = Integer.parseInt(((Element) propertyValueList.get(0)).getValue());		
			} else {
				Vector propertyValueVector = new Vector();
				for (int j=0; j< propertyValueList.size();j++){
					propertyValue = ((Element)propertyValueList.get(j)).getValue();
					propertyValueVector.add(propertyValue);
				}
				current.setProperty(propertyName,propertyValueVector);
			}
		}
		if (current.getProperty("Class").equals("javax.swing.JRootPane")){
			current.setX(x);
			current.setY(y);
		} else {
			current.setX(x+parent.getX());
			current.setY(y+parent.getY());
		}
		current.setXOffset(width);
		current.setYOffset(height);
		allGUIObject.add(current);
		
		/*
		 * check for Menus might need to change to get the correct order
		 */
		List childrenList = container.getChild("Contents").getChildren();
		for (int i=0; i< childrenList.size();i++) {
			Element child = (Element) childrenList.get(i);
			if (child.getName().equals("Container"))
				current.addChild(parseContainer(child,current,window));
			else if (child.getName().equals("Widget"))
				current.addChild(parseWidget(child,current,window));
		}
/*
		List containerList = container.getChild("Contents").getChildren("Container");
		for (int i=0;i<containerList.size();i++){
			current.addChild(parseContainer((org.jdom.Element) containerList.get(i), current,window));
		}
		List widgetList = container.getChild("Contents").getChildren("Widget");
		for (int i=0;i<widgetList.size();i++){
			current.addChild(parseWidget((org.jdom.Element) widgetList.get(i), current,window));
		}
*/
		return current;
	}
	private GUIObject parseWidget(org.jdom.Element container,GUIObject parent,GUIObject window){
		GUIObject current = new GUIObject("Widget");
		String title,str;
		int x=0, y=0, width=0, height=0;
		int intValue;
		org.jdom.Element property;
		String propertyName,propertyValue;
		
		current.setParent(parent);
		current.setWindow(window);
		
		List propertyList = container.getChild("Attributes").getChildren("Property");		
		
		for (int i=0; i< propertyList.size();i++){
			property = (org.jdom.Element) propertyList.get(i);
			//System.out.println("BBBGGG"+property.getName());
			propertyName = property.getChildText("Name");
			List propertyValueList = property.getChildren("Value");
			if (propertyName.equals("Width")) {
				width = Integer.parseInt(((Element) propertyValueList.get(0)).getValue());
			} else if (propertyName.equals("Height")) {
				height = Integer.parseInt(((Element) propertyValueList.get(0)).getValue());
			} else if (propertyName.equals("X")) {
				x = Integer.parseInt(((Element) propertyValueList.get(0)).getValue());
			} else if (propertyName.equals("Y")) {
				y = Integer.parseInt(((Element) propertyValueList.get(0)).getValue());		
			} else {
				Vector propertyValueVector = new Vector();
				for (int j=0; j< propertyValueList.size();j++){
					propertyValue = ((Element)propertyValueList.get(j)).getValue();
					propertyValueVector.add(propertyValue);
				}
				current.setProperty(propertyName,propertyValueVector);
			}
		}
		current.setX(x+parent.getX());
		current.setY(y+parent.getY());
		current.setXOffset(width);
		current.setYOffset(height);
		allGUIObject.add(current);
		
		Vector invokeVector = current.getProperty("Invokelist");
		if (invokeVector != null){
			for (int i=0; i < invokeVector.size();i++){
				String invokedGUITitle = (String) invokeVector.elementAt(i);
				current.addInvoke(invokedGUITitle);
				invokeMap.put(invokedGUITitle,current);
			}
			//System.out.println("\t\t"+(String)invokeVector.elementAt(i));
		}
		
		return current;
	}
	
	private GUIObject findEFGBaseWindow(GUIObject guiObject) {
		GUIObject nextFocusedWindow=null;
		GUIObject callingWidget;
		if (guiObject == null)
			return null;
		if (guiObject .getPropertyString("Class").equals("javax.swing.JMenuItem")){
			return guiObject.getParent();
		} else if (guiObject.getPropertyString("Class").equals("javax.swing.JMenu") &&
				guiObject.getParent().getPropertyString("Class").equals("javax.swing.JMenu")){
			return guiObject.getParent();
		}
		if (guiObject.getType().equals("GUI")){
			nextFocusedWindow = guiObject;
		} else if (guiObject.getPropertyString("Type").equals("TERMINAL")){
			nextFocusedWindow= guiObject.getWindow();
			if (nextFocusedWindow != null){ 
				callingWidget=nextFocusedWindow.getInvokerObject();
				if (callingWidget !=null){
					nextFocusedWindow = callingWidget.getWindow();
				}else {
					System.out.print("GUIParse:finalBaseWindow: ");
					System.out.println("TERMINAL widget has no calling widget");
					guiObject.print();
					return null;
				}
			}else {
				System.out.print("GUIParser:finalBaseWindow: ");
				System.out.println("TERMINAL widget has no window");
				guiObject.print();
				return null;
			}
		} else {
			nextFocusedWindow=guiObject.getWindow();
		}
		while ( (nextFocusedWindow != null) &&
				!(nextFocusedWindow.getPropertyString("Rootwindow").equals("true")) &&
				!(nextFocusedWindow.getPropertyString("Modal").equals("true"))){
			callingWidget = nextFocusedWindow.getInvokerObject();
			if (callingWidget !=null){
				nextFocusedWindow = callingWidget.getWindow();
			}else {
				System.out.print("GUIParse:finalBaseWindow in while: ");
				System.out.println("TERMINAL widget has no calling widget");
				guiObject.print();
				return null;
			}
		}
		return nextFocusedWindow;
	}
		
	public Vector getGUIObjects(){
		return allGUIObject;
	}

	public boolean isValid() {return isValid;}

	public static void main(String[] args){
		try {
		
			//GUIParser parser = new GUIParser("TerpWord3gui", false, new URL("http://www.cs.umd.edu/~bingan/req7/"));
			GUIParser parser = new GUIParser("TerpPaint3.GUI", false, null);
			Vector allGUIObject = parser.getGUIObjects();
			int iAction=0;
			for (int i=0; i< allGUIObject.size();i++){
				//((GUIObject)allGUIObject.elementAt(i)).print();
				GUIObject guiObject = (GUIObject)allGUIObject.elementAt(i);
				String componentString = guiObject.getPropertyString("Title");
				Vector replayActionsVector = guiObject.getProperty("ReplayableAction");
				if (replayActionsVector != null &&
					replayActionsVector.size() > 0) {
					iAction++;
					System.out.print(iAction+"\t"+componentString+":");
					for (int j =0; j< replayActionsVector.size();j++) {
						System.out.print(replayActionsVector.elementAt(j)+",");
					}

					System.out.println("");
				}
			}
		//} catch (MalformedURLException e){
		} catch (Exception e) {
		}
	}
}
