import java.util.Vector;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

public class GUIToOracleInfoConvertor
{
	HashMap windowMaps;
	Vector windowOracleInfoVector;
	Vector componentOracleInfoVector;
	boolean isValid;
	GUIToOracleInfoConvertor(Vector allGUIObjectVector)
	{
		GUIObject guiComponent;
		if (allGUIObjectVector==null)
		{
			isValid=false;
			return;
		}

		windowMaps=new HashMap();
		windowOracleInfoVector= new Vector();
		componentOracleInfoVector = new Vector();

		/* convert window object first */
		for (int i=0; i<  allGUIObjectVector.size();i++)
		{
			guiComponent = (GUIObject) allGUIObjectVector.elementAt(i);
			if (guiComponent.getType().equals("GUI"))
			{
				OracleInfoComponent oracleInfoComponent=
					convert(guiComponent);
			}
		}

		/* converting the rest */

		for (int i=0; i< allGUIObjectVector.size(); i++)
		{
			guiComponent = (GUIObject) allGUIObjectVector.elementAt(i);
			if (!guiComponent.getType().equals("GUI"))
			{
				OracleInfoComponent oracleInfoComponent=
					convert(guiComponent);
			}
		}
		isValid=true;
	}

	public Vector getWindows()
	{
		if (isValid==false)
			return null;
		return windowOracleInfoVector;
	}

	public Vector getComponents()
	{
		if (isValid==false)
			return null;
		return componentOracleInfoVector;
	}

	public boolean isValid()
	{
		return isValid;
	}

	public OracleInfoComponent convert(GUIObject guiComponent)
	{
		OracleInfoComponent oracleInfoComponent,windowOracleInfoComponent;
		if (guiComponent == null)
			return null;
		if (guiComponent.getType().equals("GUI"))
		{
			oracleInfoComponent=new OracleInfoComponent(OracleInfoComponent.GUI);
			String windowName = guiComponent.getPropertyString("Title");
			/* might have multiple NULL title window */
			if (windowName == null || windowName.equals(""))
			{
				windowName="NULL_TITLE";
			}
			windowMaps.put(windowName,oracleInfoComponent);
			windowOracleInfoVector.add(oracleInfoComponent);
		}
		else
		//else if (guiComponent.getType()==GUIObject.Component)
		{
			oracleInfoComponent=new OracleInfoComponent(OracleInfoComponent.Component);
			if (guiComponent.getWindow() == null)
			{
				System.out.println("Error: component has no window");
				System.out.println("\tcomponent:"+guiComponent.getPropertyString("Title"));
				return null;
			}
			String windowName = guiComponent.getWindow().getPropertyString("Title");
			windowOracleInfoComponent = (OracleInfoComponent) windowMaps.get(windowName);
			/* not correctly identify everything here */
			if (windowOracleInfoComponent == null)
			{
				System.out.println("Error: component has no window name");
				System.out.println("\tcomponent:"+guiComponent.getPropertyString("Title"));
				System.out.println("\twindow:"+windowName);
				return null;
			}
			windowOracleInfoComponent.addChild(oracleInfoComponent);
			oracleInfoComponent.addParent(windowOracleInfoComponent);
			componentOracleInfoVector.add(oracleInfoComponent);
		}
/*
		else if (guiComponent.getType()==GUIObject.Menu)
			oracleInfoComponent=new OracleInfoComponent(OracleInfoComponent.Menu);
		else
			return null;
*/

		HashMap guiProperties=guiComponent.getHashedProperties();
		Iterator guiIterator = guiProperties.keySet().iterator();
		Vector propertyValueVector;
		while (guiIterator.hasNext())
		{
			String propertyName=(String)guiIterator.next();
			propertyValueVector = guiComponent.getProperty(propertyName);
			oracleInfoComponent.addProperty(propertyName, propertyValueVector);
		}
		/* add X, Y, XOffset, YOffset */
		propertyValueVector=new Vector();
		int propertyValue;
		if (guiComponent.getParent() == null)
			propertyValue=guiComponent.getX();
		else
			propertyValue=guiComponent.getX()-guiComponent.getParent().getX();
		propertyValueVector.add(""+propertyValue);
		oracleInfoComponent.addProperty("X",propertyValueVector);

		propertyValueVector=new Vector();
		propertyValue=guiComponent.getXOffset();
		propertyValueVector.add(""+propertyValue);
		oracleInfoComponent.addProperty("Width",propertyValueVector);

		propertyValueVector=new Vector();
		if (guiComponent.getParent() == null)
			propertyValue=guiComponent.getY();
		else
			propertyValue=guiComponent.getY()-guiComponent.getParent().getY();
		propertyValueVector.add(""+propertyValue);
		oracleInfoComponent.addProperty("Y",propertyValueVector);

		propertyValueVector=new Vector();
		propertyValue=guiComponent.getYOffset();
		propertyValueVector.add(""+propertyValue);
		oracleInfoComponent.addProperty("Height",propertyValueVector);

		return oracleInfoComponent;

	}
	public void printOracleComponent(OracleInfoComponent component)
	{
		if (component==null || 
			component.getComponentType()==OracleInfoComponent.GUI)
			return;
		System.out.println("\t<Component>");
		Set keyset=component.getPropertiesKeySet();
		Iterator keyIterator=keyset.iterator();
		while (keyIterator.hasNext())
		{
			String name=(String)keyIterator.next();
			System.out.print("\t\t<Property><Name>"+name+"</Name>");
			Vector valueVector = component.getPropertyValue(name);
			for (int i=0; i< valueVector.size(); i++)
			{
				String value=(String) valueVector.elementAt(i);
				System.out.print("<Value>"+value+"</Value>");
			}
			System.out.println("</Property>");
		}
		System.out.println("\t</Component>");
	}
	public void printOracleInfo()
	{
		for (int i=0; i<windowOracleInfoVector.size(); i++)
		{
			OracleInfoComponent gui=
				(OracleInfoComponent)windowOracleInfoVector.elementAt(i);
			System.out.println("<GUI>");
			System.out.println("\t<Window>");
			System.out.println("\t\t<Attribute>");
			Set keyset=gui.getPropertiesKeySet();
			Iterator keyIterator=keyset.iterator();
			while (keyIterator.hasNext())
			{
				String name=(String)keyIterator.next();
				System.out.print("\t\t\t<Property><Name>"+name+"</Name>");
				Vector valueVector = gui.getPropertyValue(name);
				for (int j=0; j< valueVector.size(); j++)
				{
					String value=(String) valueVector.elementAt(j);
					System.out.print("<Value>"+value+"</Value>");
				}
				System.out.println("");
			}
			
			System.out.println("\t\t</Attribute>");
			System.out.println("\t</Window>");
			Vector componentVector = gui.getChildrenVector();
			for (int j=0;j<componentVector.size();j++)
			{
				printOracleComponent(
					(OracleInfoComponent) componentVector.elementAt(j));
			}
				
			System.out.println("</GUI>");
		}
	}

	public static void usage() 
	{
		System.out.println("Usage: java GUIToOracleInfoConvertor <gui file>");
		System.exit(0); 
	}

	public static void main(String args[]) 
	{
		if (args.length != 1) {
			usage();
		}

		try {
			GUIParser parser = new GUIParser(args[0], false, null);
            Vector allGUIObject = parser.getGUIObjects();

			
			GUIToOracleInfoConvertor convertor = new GUIToOracleInfoConvertor(allGUIObject);
			if (convertor.isValid() == false) {
				System.out.println("Error: Converting failure");
				System.exit(0);
			}

			convertor.printOracleInfo();
			/*
			Vector guiVector=convertor.getWindows();
			for (int i = 0; i < guiVector.size(); i++ ) {
				OracleInfoComponent gui = (OracleInfoComponent) guiVector.elementAt(i);
				gui.print();
			}
			*/

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
