import javax.swing.JDialog;
import java.awt.Frame;
import javax.swing.JTextField;
import javax.swing.JPanel;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentAdapter;
import javax.swing.JButton;
import javax.swing.JLabel;
import java.awt.BorderLayout;
import java.awt.GridLayout;

public class JDualOptionDialog implements ActionListener{
	JDialog dialog;
	String optionValue1,optionValue2;
	JTextField textField1,textField2;
	boolean isCancelled=false;
	JDualOptionDialog(String title,String optionName1,String optionName2) {
		this(title,optionName1,optionName2,null,true);
	}
	JDualOptionDialog(String title, String optionName1,String optionName2, Frame owner, boolean isModal) {
		dialog = new JDialog(owner, title, isModal);

		JPanel fieldPanel = new JPanel();
		fieldPanel.setLayout(new GridLayout(2,2));

		fieldPanel.add(new JLabel(optionName1));
		textField1 = new JTextField();
		fieldPanel.add(textField1);
		fieldPanel.add(new JLabel(optionName2));
		textField2 = new JTextField();
		fieldPanel.add(textField2);
		dialog.getContentPane().add(fieldPanel,BorderLayout.CENTER);

		JPanel buttonPanel = new JPanel();

		JButton setButton = new JButton("Set");
		setButton.addActionListener(this);
		buttonPanel.add(setButton);
		
		JButton cancelButton = new JButton("Cancel");
		cancelButton.addActionListener(this);
		buttonPanel.add(cancelButton);

		dialog.getContentPane().add(buttonPanel,BorderLayout.SOUTH);


		dialog.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		dialog.setResizable(false);
		dialog.setDefaultLookAndFeelDecorated(true);
/*
		addWindowListener( new WindowAdapter() {
			public void windowClosing(WindowEvent we) {
				
			}
		});
*/		
		dialog.addComponentListener(new ComponentAdapter() {
			public void componentShown(ComponentEvent ce){
				textField1.requestFocusInWindow();
			}
		});
		
		dialog.pack();
		dialog.show();		
	}

	public void actionPerformed(ActionEvent e){
		//System.out.println("How's my JDialog working?"+e);
		String cmd = e.getActionCommand();
		if (cmd.equals("Cancel")){
			clearAndHide();
			isCancelled=true;
		} else if (cmd.equals("Set")){
			optionValue1=textField1.getText();
			optionValue2=textField2.getText();
			dialog.setVisible(false);
		}
	}
	
	public String getOption1() {
		return optionValue1;
	}
	
	public String getOption2() {
		return optionValue2;
	}
	
	private void clearAndHide(){
		textField1.setText(null);
		textField2.setText(null);
		dialog.setVisible(false);
	}
	public boolean isCancelled(){
		return isCancelled;
	}
}