/*
 * Created on 2005-7-29
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
import org.jdom.Element;
import org.jdom.Document;
import org.jdom.input.SAXBuilder;
import java.util.List;
import java.util.Vector;
import java.util.HashMap;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.File;
/**
 * @author csloaner
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class OracleInfoVerifier {
	static int oracleLevel=4;

	String[] ignoreNames=null;
	//HashMap replaceMap;
	Vector knownErrorVector;
	OracleInfoComparerSimple comparer;
	boolean isQuiet=false;
	OracleInfoVerifier() {
		this(null,null,null);
	}

	OracleInfoVerifier(String ignoreFileName) {
		this(ignoreFileName,null, null,null,false);
	}
	OracleInfoVerifier(String ignoreFileName,String knownErrorFilename) {
		this(ignoreFileName,knownErrorFilename, null,null,false);
	}
	OracleInfoVerifier(String ignoreFilename,File dir1, File dir2) {
		this(ignoreFilename, null, dir1, dir2,false);
	}
	OracleInfoVerifier(String ignoreFilename,String knownErrorFilename,File dir1, File dir2,boolean isQuiet) {
		this.isQuiet=isQuiet;
		loadIgnoreFile(ignoreFilename);
		loadKnownErrorFile(knownErrorFilename);
		//comparer=new DOMElementComparer(ignoreNames,replaceMap,dir1,dir2);
		comparer= new OracleInfoComparerSimple(ignoreNames, knownErrorVector,dir1,dir2);
	}
	public void setQuiet(boolean isQuiet) {
		this.isQuiet=isQuiet;
	}
	public boolean isQuiet() { return isQuiet;}
	private void outputWithMute(String s) {
		if (isQuiet == false) {
			System.out.println(s);
		}
	}
	
	public static void printUsage() {
		System.out.println("Usage: java OracleInfoVerifier [options] <oracle1> <oracle2>");
		System.out.println("Options includes,");
		System.out.println("\toptional:");
		System.out.println("\t\t-i|--ignoreFilename <ignore file name>");
		System.out.println("\t\t-r|--relativePath");
		System.out.println("\t\t-l|--oracleLevel <level> : default is 4");
		//System.out.println("\t\t-c|--checkAll");
		System.out.println("\t\t-e|--knownError <known error list file name>");
		System.out.println("\t\t-q|--quiet");
		System.exit(1);
	}
	public ErrorSummary verify(Element oracleStructure1, Element oracleStructure2,int iCheckLevel){
		 
		List oracleList1 = oracleStructure1.getChild("Testcase").getChildren("Oracleinfo");
		List oracleList2 = oracleStructure2.getChild("Testcase").getChildren("Oracleinfo");
		ErrorSummary errorSummary = new ErrorSummary();
		
		if (oracleList1.size()%oracleLevel != 0){
			errorSummary.addErrorStatus(new ErrorStatus(Constants.INCOMPLETE_ORACLE1));
			return (errorSummary);
		}
		if (oracleList2.size()%oracleLevel !=0) {
			errorSummary.addErrorStatus(new ErrorStatus(Constants.INCOMPLETE_ORACLE2));
			return (errorSummary);
		}
		if (oracleList2.size()!= oracleList1.size()){
			errorSummary.addErrorStatus(new ErrorStatus(Constants.INCOMPATIBLE_ORACLE));
			return (errorSummary);
		}
		int oracleListSize = oracleList1.size();
		//System.out.println(oracleListSize);

		for (int i = 0; i < oracleListSize; i++){
			if (System.getProperty("Debug") != null)
			{
				System.out.println("Oracleinfo number "+i);
			}
			OracleInfoParser parser1=new OracleInfoParser((Element)oracleList1.get(i));
			if (parser1.isValid()==false)
			{
				errorSummary.addErrorStatus(new ErrorStatus(Constants.PARSING_ERROR1,i/oracleLevel,i%oracleLevel+1));
				return (errorSummary);
			}
			OracleInfoParser parser2=new OracleInfoParser((Element)oracleList2.get(i));
			if (parser2.isValid()==false)
			{
				errorSummary.addErrorStatus(new ErrorStatus(Constants.PARSING_ERROR2,i/oracleLevel,i%oracleLevel+1));
				return (errorSummary);
			}
			/*
			Vector guiVector=parser2.getWindows();
			for (int j = 0; j < guiVector.size(); j++ ) {
				OracleInfoComponent gui = (OracleInfoComponent) guiVector.elementAt(j);
				gui.print();
			}
			*/
			ErrorSummary subErrorSummary = 
				comparer.checkSameContainer(parser1.getWindows(),
							parser2.getWindows(),
							i/oracleLevel,
							i%oracleLevel+1);
			if (subErrorSummary != null)
				 errorSummary.addErrorSummary(subErrorSummary);
			else
			{
				errorSummary.addErrorStatus(new ErrorStatus(Constants.NULL_COMPARISON,
								i/oracleLevel,
								i%oracleLevel+1));
			}
		}
		return (errorSummary);
	}
/*
	public void printDebugInfo() {
		comparer.printDebugInfo();
	}
*/
	private void loadKnownErrorFile(String knownErrorFilename){
		if (knownErrorFilename == null || knownErrorFilename.equals("")) {
			return;
		}
		boolean isValidErrorFile= false;
		knownErrorVector=null;
		if (knownErrorFilename != null) {
			File knownErrorFile = new File(knownErrorFilename);
			if (knownErrorFile.exists() && knownErrorFile.isFile()) {
				try {
					BufferedReader reader = new BufferedReader(new FileReader(knownErrorFile));
					knownErrorVector = new Vector();
					String lineString;
					String targetString,replaceString;
					int indexSpace = 0;
					while ((lineString = reader.readLine()) != null) {
						lineString = lineString.trim();
						//outputWithMute("Replace>"+lineString);
						knownErrorVector.add(lineString);
					}
					reader.close();
				} catch (Exception e) {e.printStackTrace();}
			}
		}
		if (isValidErrorFile == false ) {
			outputWithMute("Invalid error file, ignore errors listings");
		}
	}

	public void loadIgnoreFile(String ignoreFilename){
		if (ignoreFilename == null || ignoreFilename.equals("")) {
			return;
		}
		Vector ignoreVector = new Vector();
		try {
			File f = new File(ignoreFilename);
			BufferedReader reader = new BufferedReader(new FileReader(f));
			String line;
			while ((line = reader.readLine()) != null) {
				ignoreVector.add(line.trim());
			}
			reader.close();
			ignoreNames = (String[])ignoreVector.toArray(new String[ignoreVector.size()]);
			outputWithMute("List of ignored names");
			for (int i = 0; i < ignoreNames.length; i++) {
				outputWithMute(ignoreNames[i]+".");
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}

	public void printResultSimple(ErrorSummary summary) {
		if (summary==null)
		{
			System.out.println("Error: null ErrorSummary @ printResultSimple");
			return;
		}
		if (summary.getErrorScore()==0)
		{
			System.out.println("0,");
			return;
		}
		
		Vector errorVector=summary.getErrorLog();
		for (int i =0; i<errorVector.size(); i++)
		{
			ErrorStatus errorStatus = (ErrorStatus) errorVector.elementAt(i);
			int dErrorCode = errorStatus.getErrorCode();
			if (dErrorCode >=0) {
				System.out.println(dErrorCode+",");
			} else {
				System.out.print(dErrorCode+","+errorStatus.getErrorStage());
				System.out.print(","+errorStatus.getErrorLevel()+",");
				System.out.println(errorStatus.getErrorMessage());
				//printDebugInfo();
			}
		}
	}

	public void printResult(Vector errorVector) {
		for (int i =0; i<errorVector.size(); i++)
		{
			ErrorStatus errorStatus = (ErrorStatus) errorVector.elementAt(i);
		
			int dErrorCode = errorStatus.getErrorCode();
			//System.out.println(dErrorCode);
			if (dErrorCode >=0) {
				System.out.println("Oracles are same");
			} else {
				//printDebugInfo();
				System.out.print("Oracle difference in Stage "+errorStatus.getErrorStage());
				System.out.print(" Level " +errorStatus.getErrorLevel() +" due to ");
				switch (dErrorCode) {
					case DOMElementComparer.FAILURE_STRUCTURAL:
						System.out.println("Structural Difference.");
						break;
					case DOMElementComparer.FAILURE_VALUE:
						System.out.println("Value Difference.");
						break;
					case DOMElementComparer.FAILURE_INVALID_ENTRY:
						System.out.println("invalid entries.");
						break;
					case DOMElementComparer.FAILURE_UNKNOWN:
						System.out.println("UNKNOWN REASON.");
						break;
					case Constants.INCOMPLETE_ORACLE1:
						System.out.println("Oracle 1 is imcomplete");
						break;
					case Constants.INCOMPLETE_ORACLE2:
						System.out.println("Oracle 2 is imcomplete");
						break;
					case Constants.INCOMPATIBLE_ORACLE:
						System.out.println("Oracles have different size");
						break;
					default:
						System.out.println("undefined error code.");
				}
			}
		}
	}

	public static void main(String[] args) {
		CmdLineParser cmdLineParser = new CmdLineParser();
		CmdLineParser.Option oIgnoreFile = cmdLineParser.addStringOption('i', "ignoreFilename");
		CmdLineParser.Option oRelativePath = cmdLineParser.addBooleanOption('r',"relativePath");
		CmdLineParser.Option oOracleLevel = cmdLineParser.addIntegerOption('l',"oracleLevel");
		//CmdLineParser.Option oOracleCheckAllLevel = cmdLineParser.addBooleanOption('c',"checkAll");
		CmdLineParser.Option oKnownErrorFile = cmdLineParser.addStringOption('e',"knownError");
		CmdLineParser.Option oQuiet = cmdLineParser.addBooleanOption('q',"quiet");
		try{
			cmdLineParser.parse(args);
		}
		catch(CmdLineParser.OptionException e){
			printUsage();
		}

		String ignoreFilename = (String) cmdLineParser.getOptionValue(oIgnoreFile);
		String knownErrorFilename = (String) cmdLineParser.getOptionValue(oKnownErrorFile);
		Boolean isRelative = (Boolean) cmdLineParser.getOptionValue(oRelativePath);
		Integer integerOracleLevel = (Integer) cmdLineParser.getOptionValue(oOracleLevel);
		//Boolean isCheckAllLevel = (Boolean) cmdLineParser.getOptionValue(oOracleCheckAllLevel);
		Boolean isToBeQuiet = (Boolean) cmdLineParser.getOptionValue(oQuiet);

		if (integerOracleLevel != null && integerOracleLevel.intValue() > 0) {
			oracleLevel=integerOracleLevel.intValue();
		}


		String [] oracleFilenames = cmdLineParser.getRemainingArgs();
		if (oracleFilenames.length != 2){
			printUsage();
		}
		File oracleFile1=null, oracleFile2=null;
		Document oracleDoc1=null, oracleDoc2=null;
		Element oracleRoot1=null, oracleRoot2=null;
		SAXBuilder builder = new SAXBuilder();

		try {
			oracleFile1 = new File(oracleFilenames[0]);
			oracleDoc1 = builder.build(oracleFile1);
			oracleRoot1 = oracleDoc1.getRootElement();
		} catch (Exception e) {
			System.out.println(Constants.PARSING_ERROR1+",");
/*
			if (isCheckAllLevel == null) 
				System.out.println(IMCOMPLETE_ORACLE1+",");
			else {
				for(int i = 1; i <=oracleLevel; i++) {
					System.out.println(IMCOMPLETE_ORACLE1+",0,"+i+",");
				}
			}
*/
			System.exit(1);
		}

		try {
			oracleFile2 = new File(oracleFilenames[1]);
			oracleDoc2 = builder.build(oracleFile2);
			oracleRoot2 = oracleDoc2.getRootElement();
		} catch (Exception e) {
			System.out.println(Constants.PARSING_ERROR2+",");
/*
			if (isCheckAllLevel == null) 
				System.out.println(IMCOMPLETE_ORACLE2+",");
			else {
				for(int i = 1; i <=oracleLevel; i++) {
					System.out.println(IMCOMPLETE_ORACLE2+",0,"+i+",");
				}
			}
*/
			System.exit(1);
		}

		try {	
			OracleInfoVerifier verifier;
			if (isRelative == null) 
				verifier = new OracleInfoVerifier(ignoreFilename,knownErrorFilename);
			else
				verifier = new OracleInfoVerifier(ignoreFilename,
								knownErrorFilename,
								oracleFile1.getParentFile(),
								oracleFile2.getParentFile(),
								isToBeQuiet.booleanValue());
			//System.out.println(isToBeQuiet.booleanValue());
			//verifier.setQuiet(isToBeQuiet.booleanValue());
			ErrorSummary errorSummary = verifier.verify(oracleRoot1,oracleRoot2,0);
			verifier.printResultSimple(errorSummary);
		/*	
			if (isCheckAllLevel == null) {
				Vector errorVector = verifier.verify(oracleRoot1,oracleRoot2,0);
				verifier.printResultSimple(errorVector);
			} else {
				for(int i = 1; i <=oracleLevel; i++) {
					Vector errorVector = verifier.verify(oracleRoot1, oracleRoot2,i);
					verifier.printResultSimple(errorVector);
				}
			}
		*/
			
		} catch (Exception e){ e.printStackTrace();}
	}
}
