/*
 * Created on 2005-7-29
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
import org.jdom.Element;
import org.jdom.Document;
import org.jdom.input.SAXBuilder;
import java.util.List;
import java.util.Vector;
import java.util.HashMap;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.File;
/**
 * @author csloaner
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class OracleVerifier {
	static int oracleLevel=4;
	final static int IMCOMPLETE_ORACLE1=-6;
	final static int IMCOMPLETE_ORACLE2=-7;
	final static int IMCOMPATIBLE_ORACLE=-8;
	String[] ignoreNames=null;
	HashMap replaceMap;
	DOMElementComparer comparer;
	boolean isQuiet=false;
	OracleVerifier() {
		this(null,null,null);
	}

	OracleVerifier(String ignoreFileName) {
		this(ignoreFileName,null, null,null,false);
	}
	OracleVerifier(String ignoreFileName,String replaceFilename) {
		this(ignoreFileName,replaceFilename, null,null,false);
	}
	OracleVerifier(String ignoreFilename,File dir1, File dir2) {
		this(ignoreFilename, null, dir1, dir2,false);
	}
	OracleVerifier(String ignoreFilename,String replaceFilename,File dir1, File dir2,boolean isQuiet) {
		this.isQuiet=isQuiet;
		loadIgnoreFile(ignoreFilename);
		loadReplaceFile(replaceFilename);
		comparer=new DOMElementComparer(ignoreNames,replaceMap,dir1,dir2);
	}
	public void setQuiet(boolean isQuiet) {
		this.isQuiet=isQuiet;
	}
	public boolean isQuiet() { return isQuiet;}
	private void outputWithMute(String s) {
		if (isQuiet == false) {
			System.out.println(s);
		}
	}
	
	public static void printUsage() {
		System.out.println("Usage: java OracleVerifier [options] <oracle1> <oracle2>");
		System.out.println("Options includes,");
		System.out.println("\toptional:");
		System.out.println("\t\t-i|--ignoreFilename <ignore file name>");
		System.out.println("\t\t-r|--relativePath");
		System.out.println("\t\t-l|--oracleLevel <level> : default is 4");
		System.out.println("\t\t-c|--checkAll");
		System.out.println("\t\t-m|--replaceMap <replace file name>");
		System.out.println("\t\t-q|--quiet");
		System.exit(1);
	}
	public ErrorStatus verify(Element oracleStructure1, Element oracleStructure2,int iCheckLevel){
		 
		List oracleList1 = oracleStructure1.getChild("Testcase").getChildren("Oracleinfo");
		List oracleList2 = oracleStructure2.getChild("Testcase").getChildren("Oracleinfo");
		
		if (oracleList1.size()%oracleLevel != 0){
			return (new ErrorStatus(IMCOMPLETE_ORACLE1));
		}
		if (oracleList2.size()%oracleLevel !=0) {
			return (new ErrorStatus(IMCOMPLETE_ORACLE2));
		}
		if (oracleList2.size()!= oracleList1.size()){
			return (new ErrorStatus(IMCOMPATIBLE_ORACLE));
		}
		int oracleListSize = oracleList1.size();
		//System.out.println(oracleListSize);

		if ( iCheckLevel == 0 ) {
		
			for (int i = 0; i < oracleListSize; i++){
				//System.out.println("Oracleinfo number "+i);
				int dOracleInfoComparisonResult = 
					comparer.isSame((Element)oracleList1.get(i),
								(Element)oracleList2.get(i));
				if (dOracleInfoComparisonResult <0){
					return (new ErrorStatus(dOracleInfoComparisonResult,
										i/oracleLevel,
										i%oracleLevel+1));
				}
			}
		} else {
			for (int i=0; i < oracleListSize /oracleLevel; i++ ) {
				int dOracleInfoComparisonResult =
					comparer.isSame((Element)oracleList1.get(i*oracleLevel+iCheckLevel-1),
							(Element)oracleList2.get(i*oracleLevel+iCheckLevel-1));
				if (dOracleInfoComparisonResult <0) {
					return (new ErrorStatus(dOracleInfoComparisonResult,i,iCheckLevel));
				}
			}
		}
		//System.out.println("hello");
		return (new ErrorStatus(0));
	}
	public void printDebugInfo() {
		comparer.printDebugInfo();
	}
	private void loadReplaceFile(String replaceFilename){
		if (replaceFilename == null || replaceFilename.equals("")) {
			return;
		}
		boolean isValidTranslateMap= false;
                replaceMap=null;
                if (replaceFilename != null) {
                        File replaceFile = new File(replaceFilename);
                        if (replaceFile.exists() && replaceFile.isFile()) {
                                try {
                                        BufferedReader reader = new BufferedReader(new FileReader(replaceFile));
                                        replaceMap = new HashMap();
                                        String lineString;
                                        String targetString,replaceString;
                                        int indexSpace = 0;
                                        while ((lineString = reader.readLine()) != null) {
                                                lineString = lineString.trim();
                                                outputWithMute("Replace>"+lineString);
                                                indexSpace = lineString.indexOf('|');
                                                if (indexSpace >0) {
                                                        targetString = lineString.substring(0,indexSpace);
                                                        replaceString = lineString.substring(indexSpace+1);
                                                        replaceMap.put(targetString,replaceString);
                                                        outputWithMute(targetString+"="+replaceString+"|");
                                                        isValidTranslateMap = true;
                                                }
                                        }
                                        reader.close();
                                } catch (Exception e) {e.printStackTrace();}
                        }
                }
                if (isValidTranslateMap == false ) {
                        outputWithMute("Invalid replace file, ignore translation");
                }
	}
	public void loadIgnoreFile(String ignoreFilename){
		if (ignoreFilename == null || ignoreFilename.equals("")) {
			return;
		}
		Vector ignoreVector = new Vector();
		try {
			File f = new File(ignoreFilename);
			BufferedReader reader = new BufferedReader(new FileReader(f));
			String line;
			while ((line = reader.readLine()) != null) {
				ignoreVector.add(line.trim());
			}
			reader.close();
			ignoreNames = (String[])ignoreVector.toArray(new String[ignoreVector.size()]);
			outputWithMute("List of ignored names");
			for (int i = 0; i < ignoreNames.length; i++) {
				outputWithMute(ignoreNames[i]+".");
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}

	public void printResultSimple(ErrorStatus errorStatus) {
		int dErrorCode = errorStatus.getErrorCode();
		if (dErrorCode >=0) {
			System.out.println(dErrorCode+",");
		} else {
			System.out.print(dErrorCode+","+errorStatus.getErrorStage());
			System.out.print(","+errorStatus.getErrorLevel()+",");
			printDebugInfo();
		}
	}

	public void printResult(ErrorStatus errorStatus) {
		int dErrorCode = errorStatus.getErrorCode();
		//System.out.println(dErrorCode);
		if (dErrorCode >=0) {
			System.out.println("Oracles are same");
		} else {
			printDebugInfo();
			System.out.print("Oracle difference in Stage "+errorStatus.getErrorStage());
			System.out.print(" Level " +errorStatus.getErrorLevel() +" due to ");
			switch (dErrorCode) {
				case DOMElementComparer.FAILURE_STRUCTURAL:
					System.out.println("Structural Difference.");
					break;
				case DOMElementComparer.FAILURE_VALUE:
					System.out.println("Value Difference.");
					break;
				case DOMElementComparer.FAILURE_INVALID_ENTRY:
					System.out.println("invalid entries.");
					break;
				case DOMElementComparer.FAILURE_UNKNOWN:
					System.out.println("UNKNOWN REASON.");
					break;
				case IMCOMPLETE_ORACLE1:
					System.out.println("Oracle 1 is imcomplete");
					break;
				case IMCOMPLETE_ORACLE2:
					System.out.println("Oracle 2 is imcomplete");
					break;
				case IMCOMPATIBLE_ORACLE:
					System.out.println("Oracles have different size");
					break;
				default:
					System.out.println("undefined error code.");
			}
		}
	}
/*
	public class ErrorStatus {
		int dErrorCode;
		int dErrorStage;
		int dErrorLevel;
		
		ErrorStatus(int errorCode){
			dErrorCode = errorCode;
			dErrorStage = 0;
			dErrorLevel = 0;
		}
		ErrorStatus(int errorCode, int errorStage, int errorLevel){
			dErrorCode = errorCode;
			dErrorStage = errorStage;
			dErrorLevel = errorLevel;
		}
	
		int getErrorCode() {return dErrorCode;}
		int getErrorStage(){return dErrorStage;}
		int getErrorLevel(){return dErrorLevel;}
	}
*/

	public static void main(String[] args) {
		CmdLineParser cmdLineParser = new CmdLineParser();
		CmdLineParser.Option oIgnoreFile = cmdLineParser.addStringOption('i', "ignoreFilename");
		CmdLineParser.Option oRelativePath = cmdLineParser.addBooleanOption('r',"relativePath");
		CmdLineParser.Option oOracleLevel = cmdLineParser.addIntegerOption('l',"oracleLevel");
		CmdLineParser.Option oOracleCheckAllLevel = cmdLineParser.addBooleanOption('c',"checkAll");
		CmdLineParser.Option oReplaceFile = cmdLineParser.addStringOption('m',"replaceFilename");
		CmdLineParser.Option oQuiet = cmdLineParser.addBooleanOption('q',"quiet");
		try{
			cmdLineParser.parse(args);
		}
		catch(CmdLineParser.OptionException e){
			printUsage();
		}

		String ignoreFilename = (String) cmdLineParser.getOptionValue(oIgnoreFile);
		String replaceFilename = (String) cmdLineParser.getOptionValue(oReplaceFile);
		Boolean isRelative = (Boolean) cmdLineParser.getOptionValue(oRelativePath);
		Integer integerOracleLevel = (Integer) cmdLineParser.getOptionValue(oOracleLevel);
		Boolean isCheckAllLevel = (Boolean) cmdLineParser.getOptionValue(oOracleCheckAllLevel);
		Boolean isToBeQuiet = (Boolean) cmdLineParser.getOptionValue(oQuiet);
		if (integerOracleLevel != null && integerOracleLevel.intValue() > 0) {
			oracleLevel=integerOracleLevel.intValue();
		}

		String [] oracleFilenames = cmdLineParser.getRemainingArgs();
		if (oracleFilenames.length != 2){
			printUsage();
		}
		File oracleFile1=null, oracleFile2=null;
		Document oracleDoc1=null, oracleDoc2=null;
		Element oracleRoot1=null, oracleRoot2=null;
		SAXBuilder builder = new SAXBuilder();

		try {
			oracleFile1 = new File(oracleFilenames[0]);
			oracleDoc1 = builder.build(oracleFile1);
			oracleRoot1 = oracleDoc1.getRootElement();
		} catch (Exception e) {
			System.out.println(IMCOMPLETE_ORACLE1+",");
/*
			if (isCheckAllLevel == null) 
				System.out.println(IMCOMPLETE_ORACLE1+",");
			else {
				for(int i = 1; i <=oracleLevel; i++) {
					System.out.println(IMCOMPLETE_ORACLE1+",0,"+i+",");
				}
			}
*/
			System.exit(1);
		}

		try {
			oracleFile2 = new File(oracleFilenames[1]);
			oracleDoc2 = builder.build(oracleFile2);
			oracleRoot2 = oracleDoc2.getRootElement();
		} catch (Exception e) {
			System.out.println(IMCOMPLETE_ORACLE2+",");
/*
			if (isCheckAllLevel == null) 
				System.out.println(IMCOMPLETE_ORACLE2+",");
			else {
				for(int i = 1; i <=oracleLevel; i++) {
					System.out.println(IMCOMPLETE_ORACLE2+",0,"+i+",");
				}
			}
*/
			System.exit(1);
		}

		try {	
			OracleVerifier verifier;
			if (isRelative == null) 
				verifier = new OracleVerifier(ignoreFilename,replaceFilename);
			else
				verifier = new OracleVerifier(ignoreFilename,
								replaceFilename,
								oracleFile1.getParentFile(),
								oracleFile2.getParentFile(),
								isToBeQuiet.booleanValue());
			//System.out.println(isToBeQuiet.booleanValue());
			//verifier.setQuiet(isToBeQuiet.booleanValue());
			
			if (isCheckAllLevel == null) {
				ErrorStatus errorResult = verifier.verify(oracleRoot1,oracleRoot2,0);
				verifier.printResultSimple(errorResult);
			} else {
				for(int i = 1; i <=oracleLevel; i++) {
					ErrorStatus errorResult = verifier.verify(oracleRoot1, oracleRoot2,i);
					verifier.printResultSimple(errorResult);
				}
			}
			
		} catch (Exception e){ e.printStackTrace();}
	}
}
