import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import javax.swing.JPanel;
import javax.swing.JViewport;
import java.util.Vector;
import java.awt.Graphics;
import java.awt.Dimension;
import java.awt.Color;
import java.awt.Rectangle;
import java.awt.Point;

/*
 * Created on Aug 4, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author bingan
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Overview
	extends JPanel
	implements MouseListener, MouseMotionListener,ChangeListener {

	/*
	 * Stats for Posters
	 */
	private int northPixel,southPixel,westPixel,eastPixel;
	private Vector allGUIObject;
	private int width, height;
	private int maxWidth = 200, maxHeight = 100;
	private Dimension posterDimension;
	private int scale;
	private int xOffset,yOffset;
	private Poster poster;
	/*
	 * viewport property
	 */
	private JViewport viewport;
	private int viewX,viewY,viewXOffset,viewYOffset;
	private int posterScale,posterScaleBase;
	/*
	 * draggin varaibles
	 */
	private int viewBoxX,viewBoxY,viewBoxDiffX,viewBoxDiffY,viewBoxWidth,viewBoxHeight;
	private int viewDiffX, viewDiffY;
	private int currentX,currentY;
	private boolean isSelected;
	
	Overview() {
		addMouseListener(this);
		addMouseMotionListener(this);	
		isSelected = false;
		setPreferredSize(new Dimension(maxWidth,maxHeight));
	}
	public void setAllObjects(Vector objectVector){
		allGUIObject = objectVector;
	}
	public void setPosterDimension(){
		calculateSize();
		int widthScale = (eastPixel-westPixel)/maxWidth;
		int heightScale = (southPixel-northPixel)/maxHeight;
		scale = Math.max(widthScale,heightScale)+1;
		
		width = (eastPixel-westPixel)/scale;
		height = (southPixel-northPixel)/scale;
		
		
		xOffset = westPixel;
		yOffset = northPixel;
		//setPreferredSize(new Dimension(width+1,height+1));
		//setPreferredSize(new Dimension(maxWidth,maxHeight));
		//System.out.println("Overview:setPosterDimension:west:"+westPixel+":north:"+northPixel);
	}
	public void setPosterScale(int scale){
		posterScale = scale+posterScaleBase;
	}
	public void setPosterScaleBase(int scaleBase) {
		posterScaleBase = scaleBase;
	}
	public void setViewport(JViewport window){
		viewport = window;
		viewport.addChangeListener(this);
	}
	public void setPoster(Poster bigPoster){
		poster=bigPoster;
	}
	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
	 */
	public void mouseClicked(MouseEvent e) {
//		TODO Auto-generated method stub
	}

	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mousePressed(java.awt.event.MouseEvent)
	 */
	public void mousePressed(MouseEvent e) {
		int x = e.getX();
		int y = e.getY();
		if ((x>=viewBoxX) && (x <= viewBoxX+viewBoxWidth) &&
				(y>=viewBoxY) && (x <= viewBoxX+viewBoxHeight)){
			isSelected = true;
		/*
		
		if ((x<=viewX+viewXOffset) && (x>=viewX) &&
				(y<=viewY+viewYOffset) && (y>=viewY)){				
			isSelected = true;
			viewDiffX = x - viewX;
			viewDiffY = y - viewY;	
		*/
				//System.out.println("Overview:mousePressed:Inside");	
			
			/*
			 * calculate the offset from the cursor point to the upper
			 * left corner of view box in term of overview size unit
			 */
			calculateView();	
			viewBoxDiffX=e.getX()-viewBoxX;
			viewBoxDiffY=e.getY()-viewBoxY;
		}
	}

	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseReleased(java.awt.event.MouseEvent)
	 */
	public void mouseReleased(MouseEvent e) {		
		
		isSelected = false;
	}

	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseEntered(java.awt.event.MouseEvent)
	 */
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseExited(java.awt.event.MouseEvent)
	 */
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see java.awt.event.MouseMotionListener#mouseDragged(java.awt.event.MouseEvent)
	 */
	public void mouseDragged(MouseEvent e) {
		int x=e.getX();
		int y=e.getY();
		if (isSelected) {
			if ((x>=viewBoxDiffX) && (x <= (maxWidth-viewBoxWidth+viewBoxDiffX))){
				viewX = (x-viewBoxDiffX)*scale*posterScaleBase/posterScale;
			} else if (x < viewBoxDiffX) {
				viewX = 0;
			} else {
				viewX = (maxWidth - viewBoxWidth+viewBoxDiffX)*scale*posterScaleBase/posterScale;
			}
			if ((y>=viewBoxDiffY) && (y <= (maxHeight-viewBoxHeight+viewBoxDiffY))){
				viewY = (y-viewBoxDiffY)*scale*posterScaleBase/posterScale;
			} else if (y < viewBoxDiffY) {
				viewY = 0;
			} else {
				viewY = (maxHeight-viewBoxHeight+viewBoxDiffY)*scale*posterScaleBase/posterScale;
			}
			//System.out.println("Overview:mouseDragged:viewbox X:"+(x-viewBoxDiffX)+" Y:"+(y-viewBoxDiffY));
						
			viewport.setViewPosition(new Point(viewX,viewY));
			revalidate();
			repaint();
			
		}
	}

	/* (non-Javadoc)
	 * @see java.awt.event.MouseMotionListener#mouseMoved(java.awt.event.MouseEvent)
	 */
	public void mouseMoved(MouseEvent e) {
		// TODO Auto-generated method stub

	}
	public void stateChanged(ChangeEvent e){
		calculateView();
		repaint();
	}
	private void calculateView(){
		if (viewport == null) 
			return;
		Rectangle r = viewport.getViewRect();
		viewX = (int) Math.round(r.getX());
		viewY = (int) Math.round(r.getY());
		viewXOffset = (int) Math.round(r.getWidth());
		viewYOffset = (int) Math.round(r.getHeight());
		
		viewBoxX=viewX*posterScale/posterScaleBase/scale;
		viewBoxY=viewY*posterScale/posterScaleBase/scale;
		
		viewBoxWidth = viewXOffset * posterScale/posterScaleBase/scale;
		viewBoxHeight = viewYOffset * posterScale/posterScaleBase/scale;
	}
	public void update (Graphics g){
		GUIObject tempGUIObject;
		
		calculateSize();
		setPosterDimension();
		//setPreferredSize(new Dimension(maxWidth,maxHeight));
		setBackground(Color.white);
		
		g.drawRect(0,0,maxWidth,maxHeight);
		g.drawRect(1,1,maxWidth-2,maxHeight-2);
		
		g.setColor(Color.green);

		g.drawRect(0,0,width,height);
		g.drawRect(1,1,width-2,height-2);
		
		g.setColor(Color.blue);
		/*
		 * set the viewport box
		 */
		if (viewport != null){
			/*
			System.out.println("OverView:update:viewbox X:"+viewX*posterScale/posterScaleBase/scale+
					" Y:"+viewY*posterScale/posterScaleBase/scale+
					" Width:"+viewXOffset*posterScale/posterScaleBase/scale+
					" Height:"+viewYOffset*posterScale/posterScaleBase/scale);
			*/
			g.drawRect(viewX*posterScale/posterScaleBase/scale,
						viewY*posterScale/posterScaleBase/scale,
						viewXOffset*posterScale/posterScaleBase/scale,
						viewYOffset*posterScale/posterScaleBase/scale);
		}
		
		g.translate(Math.abs(xOffset/scale),
					Math.abs(yOffset/scale));
		//System.out.println("Overview:update:xOffset:"+xOffset);
		g.setColor(Color.red);
		for (int i=0;i<allGUIObject.size();i++){
			/*  this loop only do GUI type
			 *  Reason: need to draw the jpg image first,
			 * 	then over lay the rect and string
			 */  
			tempGUIObject=(GUIObject)allGUIObject.elementAt(i);
			if (tempGUIObject.getType().equals("GUI")){
				
				g.drawRect((tempGUIObject.getFinalX())/scale,
							(tempGUIObject.getFinalY())/scale,
							(tempGUIObject.getXOffset())/scale,
							(tempGUIObject.getYOffset())/scale);
				
			}
		}
		
		g.setColor(Color.BLACK);
	}
	public void paint(Graphics g){
		super.paint(g);
		update(g);
	}
	private void calculateSize(){
		eastPixel=0;
		westPixel=0;
		southPixel=0;
		northPixel=0;
		GUIObject tempGUIObject;
		for (int i=0;i<allGUIObject.size();i++){
			/*  this loop only do GUI type
			 *  Reason: need to draw the jpg image first,
			 * 	then over lay the rect and string
			 */  
			tempGUIObject=(GUIObject)allGUIObject.elementAt(i);
			if (tempGUIObject.getType().equals("GUI")){
				/* 
				 * calculate the east, west, south, north boundary
				 */
				if (eastPixel<tempGUIObject.getFinalX()+tempGUIObject.getXOffset())
					eastPixel =tempGUIObject.getFinalX()+tempGUIObject.getXOffset();
				if (southPixel<tempGUIObject.getFinalY()+tempGUIObject.getYOffset())
					southPixel =tempGUIObject.getFinalY()+tempGUIObject.getYOffset();
				if (northPixel > tempGUIObject.getFinalY())
					northPixel = tempGUIObject.getFinalY();
				if (westPixel >tempGUIObject.getFinalX())
					westPixel = tempGUIObject.getFinalX();
							
			}
		}
		/*
		System.out.println("Poster:calculateSize():Left Boundary:"+westPixel);
		System.out.println("Poster:calculateSize():Right Boundary:"+eastPixel);
		System.out.println("Poster:calculateSize():Top Boundary:"+northPixel);
		System.out.println("Poster:calculateSize():Bottom Boundary:"+southPixel);
		*/	
	}

}
