import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import java.net.*;
import java.io.File;



/*
 * Created on May 7, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author Bin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Poster extends JPanel
implements MouseListener, MouseMotionListener
{
	/*
	 * Stats for Posters
	 */
	int northPixel,southPixel,westPixel,eastPixel;
	/*
	 * for scaling the Poster
	 */
	int scale;
	int scaleBase;
	/*
	 * for dragging images/GUI
	 */
	int mouseX=0, mouseY=0,mousePressedX=-1,mousePressedY=-1;
	GUIObject draggedGUIObject=null;
	/*
	 * list of all GUI related Objects
	 */
	private Vector allGUIObject;
	private HashMap GUIMap=new HashMap();
	private HashMap nonGUIMap=new HashMap();
	/*
	 * used to display GUI images
	 */
	
	private Image image;
	/*
	 * junk variables?
	 */
	
	private int radius;
	/*
	 * parsers for 2 input file
	 */
	private EFGParser efgParser;
	//private EFG efg;
	private EventGraph eventGraph;
	private GUIParser guiParser;
	
	/*
	 * Constants for display menu
	 */
	final private int cellWidth=100;
	final private int cellHeight=12;
	final private int cellHalfHeight=cellHeight/2;
	final private int leftOfVerticalLineSpace=20;
	final private int rightOfVerticalLineSpace=10;
	final private int treeSpace=leftOfVerticalLineSpace+rightOfVerticalLineSpace;
	final private int componentIndent=3;
	final private int flipUp=-1;
	/*
	 * flags for display properties
	 */
	boolean isPrinted = true;
	boolean enableEFG = false;
	boolean showGraphics = false;
	boolean enableComponent = true;
	boolean enableInvokelink = true;
	
	/*
	 * project variables for input names
	 * assume the suffix and also the directory for image files.
	 */
	private URL url;
	private String GUIFilename, EFGFilename,imageDirectory;
	
	/*
	 * Read mode for parse coordinate
	 */
	
	private String parseMode;
	private boolean isAbsoluteCoordinate = true;
	/*
	 * Overview object
	 */
	Overview overview;
	/*
	 * Test for better refresh
	 */
	Image offImage;
	Graphics g;
	Dimension offDimension;
	
	Poster() {
		//use parseConfig to construct
		addMouseListener(this);
		addMouseMotionListener(this);
	}
	
	public void setOverview(Overview o){
		overview = o;
	}
	
	public void parseConfig(URL urlIn,boolean isAbs,String GUIFilename, String EFGFilename, String imageDirectory){
		
		url = urlIn;
		this.GUIFilename = GUIFilename;
		this.EFGFilename = EFGFilename;
		this.imageDirectory = imageDirectory;
		isAbsoluteCoordinate = isAbs;
		
		guiParser=new GUIParser(GUIFilename,isAbsoluteCoordinate,urlIn);
		
		long myX,myY;
		int currentX,currentY,currentRowMaxY;
		boolean done;
		Vector currentRow=new Vector();
		Vector nextRow=new Vector();
		Vector tempRow;
		Vector children,grandchildren;
		GUIObject tempGUIObject,parent;
		int xMargin=30,yMargin=30;
		String tempString;
		Vector processed=new Vector();
		int dimensionX=0, dimensionY=0;
		int rounds;
		
		allGUIObject=guiParser.getGUIObjects();
		/*
		 try {
		 handler.myParse(GUIFilename,allGUIObject);
		 } catch (Exception e) {
		 System.out.println(e);
		 }
		 */
		/*
		 for (int i=0; i<allGUIObject.size();i++){
		 ((GUIObject)allGUIObject.elementAt(i)).print();
		 }
		 */
		
		// find out about all the GUI's
		for (int i=0;i<allGUIObject.size();i++){
			tempGUIObject=(GUIObject)allGUIObject.elementAt(i);
			
			if (tempGUIObject.getType().equals("GUI")){
				//System.out.println("GUI ID:"+tempGUIObject.getID());
				GUIMap.put(tempGUIObject.getPropertyString("Title"),tempGUIObject);
			}else {
				nonGUIMap.put(tempGUIObject.getParent().getPropertyString("Title")+
						tempGUIObject.getPropertyString("Title"),tempGUIObject);
			}
		}
		
		// find root, assuming the GUI is the first one
		if (allGUIObject.size()!=0){
			int psuedoRadius=0;
			Coordinate coordinate;
			
			tempGUIObject=(GUIObject) allGUIObject.firstElement();
			coordinate=new Coordinate();
			// TODO search isRootWindow
			while (tempGUIObject.getParent() != null)
				tempGUIObject=tempGUIObject.getParent();
			//System.out.println("#GUI:"+GUIMap.size());
			System.out.println("ROOT IS "+tempGUIObject.getPropertyString("Title"));
			//find position for each GUI/Menu
			currentRow.add(tempGUIObject);
			tempGUIObject.setFinal(0,0);
			currentX=0;
			currentY=tempGUIObject.getYOffset()+yMargin;
			currentRowMaxY=0;
			processed.addElement(tempGUIObject);
			radius = 0;
			rounds = 1;
			
			while (!currentRow.isEmpty()){
				//first find all the children (pass through Component)
				System.out.println("BBBGGG:expanding GUI rows"+currentRow.size());
				coordinate.setMaxX(0);
				coordinate.setMaxY(0);
				for(int i= 0;i < currentRow.size();i++){
					//get the children of the currentRow element
					children=findChildrenRecursive((GUIObject)currentRow.elementAt(i),coordinate,(GUIObject)currentRow.elementAt(i),0,0);
					if (psuedoRadius < (coordinate.getMaxX()+coordinate.getMaxY())*5/6)
						psuedoRadius = (coordinate.getMaxX()+coordinate.getMaxY())*5/6;
					//System.out.println("PseudoRadius:"+psuedoRadius);
					for (int j=0;j<children.size();j++){
						tempString=(String)children.elementAt(j);
						System.out.println("Round:"+rounds+":"+tempString);
						nextRow.addElement(GUIMap.get(tempString));
					}					
				}
				
				//Calculate the circle size
				//radius+=psuedoRadius*((nextRow.size()+7)/8);
				if (nextRow.size() > 0 )
					radius+=psuedoRadius;
				//System.out.println("BBBGGG:"+rounds+":"+radius);
				//System.out.println("BBBGGG:"+currentRow.size());
				int numberGUI=nextRow.size();
				//assign coordinates for GUIObjects in nextRow
				for (int i=0;i<nextRow.size();i++){
					tempGUIObject=(GUIObject)nextRow.elementAt(i);
					if (tempGUIObject==null)
						System.out.println("shit");
					myX=Math.round(radius*(Math.cos(((double)(i*Math.PI*2))/numberGUI)));
					myY=Math.round(radius*(Math.sin(((double)(i*Math.PI*2))/numberGUI)));
					//System.out.println(tempGUIObject.getPropertyString("Title")+":"+myX+":"+myY);	
					tempGUIObject.setFinal((int)myX,(int)myY);
					//System.out.println(tempGUIObject.getPropertyString("Title")+":"+tempGUIObject.getFinalX()+":"+tempGUIObject.getFinalY());
				}//end for i
				//switch currentRow and nextRow, clean new nextRow
				
				tempRow=currentRow;
				currentRow=nextRow;
				nextRow=tempRow;
				nextRow.removeAllElements();
				
				rounds++;
				psuedoRadius=0;
			}// end while for assgining coordinates
		}//end if empty file
		//for (int i=0; i<allGUIObject.size();i++){
		//	((GUIObject)allGUIObject.elementAt(i)).print();
		//}
		//offsets=radius+30;
		//offsets=0;
		setPreferredSize(new Dimension(radius*5,radius*5));
		
		
		// add EFG portion
		if (EFGFilename == null){
			EIG eig = new EIG();
			eig.generateEG(allGUIObject);
			eventGraph = eig.getEventGraph();
			
		} else {
			EventGraphReader eventGraphReader=new EventGraphReader(EFGFilename,allGUIObject,url);
			if (eventGraphReader.isSuccess()) {
				eventGraph = eventGraphReader.getEventGraph();
			} else {
				System.out.println("Invalid event graph file, please check");
				return;
			}
			/*
			GUIObject guiObject1, guiObject2;
		
			for (int i=0; i < eventGraph.getEGSize(); i++) {
				guiObject1 = eventGraph.getEvent(i).getEventObject();
				for (int j=0; j < eventGraph.getEGSize(); j++) {
					if (eventGraph.getEventGraphStatus(i,j) == EventGraph.VALID){
						guiObject2 = eventGraph.getEvent(j).getEventObject();
						//System.out.println("hello");
						guiObject1.addOutgoing(guiObject2);
						guiObject2.addIncoming(guiObject1);
					} 
				}
			}
			*/
		}
		//eventGraph = efg.getEventGraph();
		
		
		
		calculateSize();
	}//end constructor
	
	public void mouseClicked(MouseEvent me) {
		GUIObject doubleClickedGUIObject=null;
		mouseX=me.getX();
		mouseY=me.getY();
		
		/*
		 * Find if the click is on an GUIObject
		 */
		mouseX+=westPixel*scaleBase/scale;
		mouseY+=northPixel*scaleBase/scale;
		int numberOfClicks = me.getClickCount();
		if (numberOfClicks == 2) {
			GUIObject tempGUIObject;
			int east,west,north,south;
			boolean isFound=false;
			System.out.println("Poster:mouseClicked:doubleclick");
			for (int i=0;i < allGUIObject.size();i++){
				tempGUIObject = (GUIObject) allGUIObject.elementAt(i);
				if (tempGUIObject.getType().equals("GUI")){
					west = (tempGUIObject.getFinalX())*scaleBase/scale;
					east = west + tempGUIObject.getXOffset()*scaleBase/scale;
					north = (tempGUIObject.getFinalY())*scaleBase/scale;
					south = north + tempGUIObject.getYOffset()*scaleBase/scale;
					/*
					 if (tempGUIObject.getPropertyString("Title").equals("")){
					 System.out.println("Poster:MousePresssed:"+tempGUIObject.getPropertyString("Title"));
					 System.out.println("\tWest-"+west+":East-"+east+":North-"+north+":South-"+south);
					 }
					 */
					if (mouseX>= west && mouseX <= east &&
							mouseY>= north && mouseY <= south){
						WidgetInfo widgetInfo = new WidgetInfo(tempGUIObject);
						//showGUIProperty(tempGUIObject);
						//doubleClickedGUIObject = tempGUIObject;
						//isFound = true;
						//System.out.println("Poster:mousePressed:"+tempGUIObject.getPropertyString("Title")+" is selected");	
					}
				} else if (tempGUIObject.getType().equals("Container")|| 
						tempGUIObject.getType().equals("Widget")){
					west = (tempGUIObject.getFinalX()+tempGUIObject.getWindow().getFinalX())*scaleBase/scale;
					east = west + tempGUIObject.getXOffset()*scaleBase/scale;
					north = (tempGUIObject.getFinalY()+tempGUIObject.getWindow().getFinalY())*scaleBase/scale;
					south = north + tempGUIObject.getYOffset()*scaleBase/scale;
					String replayActionString = tempGUIObject.getPropertyString("ReplayableAction");
					if (mouseX>= west && mouseX <= east &&
							mouseY>= north && mouseY <= south &&
							 replayActionString!= null &&
							!replayActionString.equals("")){
						WidgetInfo widgetInfo = new WidgetInfo(tempGUIObject);
						//showComponentProperty(tempGUIObject);
						//doubleClickedGUIObject = tempGUIObject;
						//isFound = true;
						//System.out.println("Poster:mousePressed:"+tempGUIObject.getPropertyString("Title")+" is selected");	
					}
				}
			}
			/*
			 if ((isFound == true) && (doubleClickedGUIObject != null)){
			 showProperty(doubleClickedGUIObject);
			 }
			 */
		}
		
	}
	
	public void mousePressed(MouseEvent me) {
		mousePressedX=me.getX()+westPixel*scaleBase/scale;
		mousePressedY=me.getY()+northPixel*scaleBase/scale;
		/*
		 * search for first GUIObject pointed
		 */
		GUIObject tempGUIObject;
		int i=0,east,west,north,south;
		boolean isFound=false;
		while ( i < allGUIObject.size() && isFound == false){
			tempGUIObject = (GUIObject) allGUIObject.elementAt(i);
			if (tempGUIObject.getType().equals("GUI")){
				west = tempGUIObject.getFinalX()*scaleBase/scale;
				east = west + tempGUIObject.getXOffset()*scaleBase/scale;
				north = tempGUIObject.getFinalY()*scaleBase/scale;
				south = north + tempGUIObject.getYOffset()*scaleBase/scale;
				//System.out.println("Poster:MousePresssed:"+tempGUIObject.getPropertyString("Title"));
				//System.out.println("\tWest-"+west+":East-"+east+":North-"+north+":South-"+south);
				
				if (mousePressedX>= west && mousePressedX <= east &&
						mousePressedY>= north && mousePressedY <= south){
					draggedGUIObject = tempGUIObject;
					isFound = true;
					//System.out.println("Poster:mousePressed:"+tempGUIObject.getPropertyString("Title")+" is selected");	
				}
			} 
			i++;
		}
	}
	
	public void mouseReleased(MouseEvent me) {
		mousePressedX=-1;
		mousePressedY=-1;
		draggedGUIObject = null;
		
	}
	
	public void mouseEntered(MouseEvent me) {
	}
	
	public void mouseExited(MouseEvent me) {
	}
	
	public void mouseDragged(MouseEvent me) {
		int diffX,diffY,draggedGUIObjectX,draggedGUIObjectY;
		mouseX=me.getX()+westPixel*scaleBase/scale;
		mouseY=me.getY()+northPixel*scaleBase/scale;
		
		if (draggedGUIObject != null) {
			diffX=mouseX-mousePressedX;
			diffY=mouseY-mousePressedY;
			draggedGUIObjectX=draggedGUIObject.getFinalX();
			draggedGUIObjectY=draggedGUIObject.getFinalY();
			draggedGUIObject.setFinalX(draggedGUIObjectX+diffX*scale/scaleBase);
			draggedGUIObject.setFinalY(draggedGUIObjectY+diffY*scale/scaleBase);
			//calculateSize();
			//overview.revalidate();
			//overview.repaint();
			revalidate();
			repaint();
			
			mousePressedX=mouseX;
			mousePressedY=mouseY;
			
		}
		
		/*
		 showStatus("Dragging mouse at " +me.getX()+", " +me.getY());
		 repaint();
		 */
	}
	
	public void mouseMoved(MouseEvent me) {
		/*	
		 mouseX=me.getX();
		 mouseY=me.getY();
		 showStatus("Moving mouse at"+mouseX+", "+mouseY);
		 if (myBotton.withinArea(mouseX,mouseY)) {
		 showStatus("Moving Within Area: x at "+ mouseX +";y at "+mouseY);
		 } else {
		 showStatus("Moving mouse at " +me.getX()+", " +me.getY());
		 }
		 */	
	}
	
	public void paintComponent(Graphics graph){
		super.paintComponent(graph);
		update(graph);
	}
	public String replace(String s, String f, String r){
		if (s == null) return s;
		if (f == null) return s;
		if (r == null) r = "";
		
		int index = s.indexOf(f);
		while (index != -1){
			s=s.substring(0,index)+r+s.substring(index+f.length());
			index += r.length();
			index = s.indexOf(f,index);
		}
		return s;
	}
	
	public void setScaleBase(int inputScaleBase){
		scaleBase = inputScaleBase;
		scale = scaleBase;
	}
	public void setScale(int inputScale){
		scale = inputScale;
	}
	public int getScaleBase(){
		return scaleBase;
	}
	public void setRatio(int ratio,JViewport jvp){
		int oldScale = scale;
		/*
		 * get the current upper left viewport position
		 */
		Rectangle r = jvp.getViewRect();
		double localX = r.getX();
		double localY = r.getY();
		double localHalfWidth = r.getWidth()/2;
		double localHalfHeight = r.getHeight()/2;
		System.out.println("\t"+localX+":"+localY+":"+localHalfWidth+":"+localHalfHeight);
		
		/*
		 * calculate the center point
		 */
		double centerX=localX+localHalfWidth;
		double centerY=localY+localHalfHeight;
		/*
		 * get the current scale
		 */
		scale=ratio+scaleBase;
		
		/*
		 * calculate the scaled new position
		 */
		double localNewX = centerX*oldScale/scale-localHalfWidth;
		if (localNewX < 0) localNewX=0;
		
		double localNewY = centerY*oldScale/scale-localHalfHeight;
		if (localNewY < 0) localNewY = 0;
		
		//System.out.println("Poster:setRatio:|"+ centerX*oldScale/scale+"|"+centerY*oldScale/scale+"|"+localNewX+"|"+localNewY);
		//calculateSize();
		revalidate();
		
		/*
		 * change the viewport position
		 */
		jvp.setViewPosition(new Point((int)Math.round(localNewX),
				(int)Math.round(localNewY)));
		/*
		 * reset scale
		 */
		repaint();
	}
	public void paint(Graphics g){
		super.paint(g);
		update(g);
	}
	
	public void update(Graphics g) {
		GUIObject tempGUIObject;
		int xFinalOffset=0,yFinalOffset=0;
		int east=0,west=0,south=0,north=0;
		boolean isVisibleComponent;
		
		calculateSize();
		/*
		 Dimension d=getOverallSize(); 
		 if ((g==null)||(offDimension.width!=d.width)||(offDimension.height!=d.height)){ 
		 offDimension=d; 
		 offImage=createImage(d.width,d.height);
		 g=offImage.getGraphics(); 
		 }
		 offImage.flush();
		 g.setColor(getBackground());
		 */
		//System.out.println("BBBGGG:Poster:update:UpperLeft="+westPixel+":"+northPixel);
		g.translate(Math.abs(westPixel*scaleBase/scale),
				Math.abs(northPixel*scaleBase/scale));
		/*
		 g.fillRect(westPixel,northPixel,eastPixel-westPixel,southPixel-northPixel);
		 g.setColor(Color.black);
		 */
		Font font = g.getFont();
		String fontName = font.getName();
		int fontSize=font.getSize();
		
		g.setFont(new Font(fontName,Font.PLAIN,fontSize*scaleBase/scale));
		//System.out.println("--------------------------");
		for (int i=0;i<allGUIObject.size();i++){
			/*  this loop only do GUI type
			 *  Reason: need to draw the jpg image first,
			 * 	then over lay the rect and string
			 */  
			tempGUIObject=(GUIObject)allGUIObject.elementAt(i);
			if (tempGUIObject.getType().equals("GUI")){
				/*	
				 * 
				 
				 System.out.println((int)i+"|"+
				 tempGUIObject.getPropertyString("Title")+":"+
				 tempGUIObject.getFinalX()+":"+
				 tempGUIObject.getFinalY()+":"+
				 tempGUIObject.getXOffset()+":"+
				 tempGUIObject.getYOffset());
				 */
				
				g.drawRect((tempGUIObject.getFinalX())*scaleBase/scale,
						(tempGUIObject.getFinalY())*scaleBase/scale,
						(tempGUIObject.getXOffset())*scaleBase/scale,
						(tempGUIObject.getYOffset())*scaleBase/scale);
				/* 
				 * calculate the east, west, south, north boundary
				 */
				if (east<(tempGUIObject.getFinalX()+tempGUIObject.getXOffset())*scaleBase/scale)
					east =(tempGUIObject.getFinalX()+tempGUIObject.getXOffset())*scaleBase/scale;
				if (south<(tempGUIObject.getFinalY()+tempGUIObject.getYOffset())*scaleBase/scale)
					south =(tempGUIObject.getFinalY()+tempGUIObject.getYOffset())*scaleBase/scale;
				if (north > (tempGUIObject.getFinalY())*scaleBase/scale)
					north = (tempGUIObject.getFinalY())*scaleBase/scale;
				if (west >(tempGUIObject.getFinalX())*scaleBase/scale)
					west = (tempGUIObject.getFinalX())*scaleBase/scale;
				if (showGraphics == false){
					
						g.drawString(tempGUIObject.getPropertyString("Title"),
							(tempGUIObject.getFinalX()+cellHeight)*scaleBase/scale,
							(tempGUIObject.getFinalY()+cellHeight)*scaleBase/scale);
					
					
				} else {
					/*
					 scaledImage = image.getScaledInstance(tempGUIObject.getXOffset()*scaleBase/scale,
					 tempGUIObject.getYOffset()*scaleBase/scale,
					 Image.SCALE_DEFAULT);
					 */
					image = tempGUIObject.scaleImage(scale,scaleBase);
					if (image != null){
						g.drawImage(image,
								(tempGUIObject.getFinalX())*scaleBase/scale,
								(tempGUIObject.getFinalY())*scaleBase/scale,
								this);
					}
				}			
			}
		}
		
		for (int i=0;i<allGUIObject.size();i++){
			tempGUIObject=(GUIObject)allGUIObject.elementAt(i);
			xFinalOffset=0;
			yFinalOffset=0;
			
			GUIObject tempRootObject=tempGUIObject.getWindow();
			if (tempRootObject == null){
				if (isPrinted == false) {
					System.out.println("BBBGGGa:"+tempGUIObject.getPropertyString("Title"));
				}
			}else {
				xFinalOffset=tempRootObject.getFinalX();
				yFinalOffset=tempRootObject.getFinalY();
			}
			/*if (tempGUIObject.getType().equals("Container") ||
			 tempGUIObject.getType().equals("Widget")){*/
			/*if (tempGUIObject.getPropertyString("Class").equals("javax.swing.JMenuBar")) {
				//should do nothing ? or draw the menu bar?
				
				g.drawString(tempGUIObject.getPropertyString("Title"),
						(tempGUIObject.getFinalX()+xFinalOffset)*scaleBase/scale,
						((tempGUIObject.getFinalY()+cellHeight)*flipUp+yFinalOffset)*scaleBase/scale);
				
				//draw vertical line connecting menu components
				g.drawLine((tempGUIObject.getFinalX()-rightOfVerticalLineSpace+xFinalOffset)*scaleBase/scale,
						(tempGUIObject.getFinalY()+yFinalOffset)*scaleBase/scale,
						(tempGUIObject.getFinalX()-rightOfVerticalLineSpace+xFinalOffset)*scaleBase/scale,
						((tempGUIObject.getFinalY()+cellHeight+cellHalfHeight+(tempGUIObject.getChildren().size())*12)*flipUp+ yFinalOffset)*scaleBase/scale);						
				
			} else if (tempGUIObject.getPropertyString("Class").equals("javax.swing.JMenu")) {*/

			if (tempGUIObject.getPropertyString("Class").equals("javax.swing.JMenu") ||
			    tempGUIObject.getPropertyString("Class").equals("rath.jmsn.ui.WrapMenu")) {
				//wrtie the menu name
				g.setColor(Color.blue);
				if (tempGUIObject.getParent().getPropertyString("Class").equals("javax.swing.JMenu") ||
				    tempGUIObject.getParent().getPropertyString("Class").equals("rath.jmsn.ui.WrapMenu")) {
					/*
					g.drawString("separator",
						(tempGUIObject.getFinalX()+componentIndent+xFinalOffset)*scaleBase/scale,
						((tempGUIObject.getFinalY()+cellHeight*2)*flipUp+yFinalOffset)*scaleBase/scale);
					g.drawString(tempGUIObject.getPropertyString("Title"),
						(tempGUIObject.getFinalX()+componentIndent+xFinalOffset)*scaleBase/scale,
						((tempGUIObject.getFinalY()+cellHeight*2)*flipUp+yFinalOffset)*scaleBase/scale);
				
					*/
					g.drawString(tempGUIObject.getPropertyString("Title"),
						(tempGUIObject.getFinalX()+componentIndent+xFinalOffset)*scaleBase/scale,
						((tempGUIObject.getFinalY()+cellHeight*2)*flipUp+yFinalOffset)*scaleBase/scale);
					g.drawRect((tempGUIObject.getFinalX()+componentIndent+xFinalOffset)*scaleBase/scale,
						((tempGUIObject.getFinalY()+cellHeight*3)*flipUp+yFinalOffset)*scaleBase/scale,
						cellWidth*scaleBase/scale,
						cellHeight*scaleBase/scale);
					//System.out.println("Looking for submenu "+tempGUIObject.getPropertyString("Title"));
				} else {
					g.drawString(tempGUIObject.getPropertyString("Title"),
						(tempGUIObject.getFinalX()+xFinalOffset)*scaleBase/scale,
						(tempGUIObject.getFinalY()+yFinalOffset+cellHeight)*scaleBase/scale);
				}
				// line from menu to menu list
				Vector childrenVector = tempGUIObject.getChildren();
				if (childrenVector != null && childrenVector.size()>0){
					GUIObject firstChild = (GUIObject) childrenVector.elementAt(0);
					SimpleArrow arrow;
					if (tempGUIObject.getParent().getPropertyString("Class").equals("javax.swing.JMenu") ||
					    tempGUIObject.getParent().getPropertyString("Class").equals("rath.jmsn.ui.WrapMenu"))
						arrow = new SimpleArrow((tempGUIObject.getFinalX()+cellWidth+componentIndent+xFinalOffset)*scaleBase/scale,
							((tempGUIObject.getFinalY()+cellHalfHeight+cellHeight*2)*flipUp+yFinalOffset)*scaleBase/scale,
							(firstChild.getFinalX()+xFinalOffset)*scaleBase/scale,
							((firstChild.getFinalY()+cellHeight*2)*flipUp+yFinalOffset)*scaleBase/scale);
					else 
						arrow = new SimpleArrow((tempGUIObject.getFinalX()+tempGUIObject.getXOffset()/2+xFinalOffset)*scaleBase/scale,
							(tempGUIObject.getFinalY()+yFinalOffset)*scaleBase/scale,
							(firstChild.getFinalX()+xFinalOffset)*scaleBase/scale,
							((firstChild.getFinalY()+cellHeight*2)*flipUp+yFinalOffset)*scaleBase/scale);
					arrow.paint(g,30);
				}
				g.setColor(Color.black);
				
				g.drawRect((tempGUIObject.getFinalX()+xFinalOffset)*scaleBase/scale,
						(tempGUIObject.getFinalY()+yFinalOffset)*scaleBase/scale,
						(tempGUIObject.getXOffset())*scaleBase/scale,
						(tempGUIObject.getYOffset())*scaleBase/scale);
				if (tempGUIObject.getParent().getPropertyString("Class").equals("javax.swing.JMenuBar")){
				} else {
					
				}
			} else if (tempGUIObject.getPropertyString("Class").equals("javax.swing.JMenuItem") ||
					tempGUIObject.getPropertyString("Class").equals("javax.swing.JRadioButtonMenuItem") ||
					tempGUIObject.getPropertyString("Class").equals("javax.swing.JCheckBoxMenuItem") ||
					tempGUIObject.getPropertyString("Class").equals("javax.swing.JMenu$1") ||
					tempGUIObject.getPropertyString("Class").equals("rath.jmsn.ui.WrapMenuItem")){	
				g.drawString(tempGUIObject.getPropertyString("Title"),
						(tempGUIObject.getFinalX()+componentIndent+xFinalOffset)*scaleBase/scale,
						((tempGUIObject.getFinalY()+cellHeight*2)*flipUp+yFinalOffset)*scaleBase/scale);
				// draw the little line in front of each menu|component
				/*g.drawLine((tempGUIObject.getFinalX()-rightOfVerticalLineSpace+xFinalOffset)*scaleBase/scale,
						((tempGUIObject.getFinalY()+cellHeight*2+cellHalfHeight)*flipUp+yFinalOffset)*scaleBase/scale,
						(tempGUIObject.getFinalX()+xFinalOffset)*scaleBase/scale,
						((tempGUIObject.getFinalY()+cellHeight*2+cellHalfHeight)*flipUp+yFinalOffset)*scaleBase/scale);*/
				
				
				g.drawRect((tempGUIObject.getFinalX()+componentIndent+xFinalOffset)*scaleBase/scale,
						((tempGUIObject.getFinalY()+cellHeight*3)*flipUp+yFinalOffset)*scaleBase/scale,
						cellWidth*scaleBase/scale,
						cellHeight*scaleBase/scale);
				
				Vector children=tempGUIObject.getInvokeList();
				GUIObject child;
				for (int j=0;j<children.size();j++){
					child=(GUIObject)GUIMap.get((String)children.elementAt(j));
					if (child.getType().equals("GUI") && enableInvokelink){	
						SimpleArrow arrow = new SimpleArrow((tempGUIObject.getFinalX()+cellWidth+componentIndent+xFinalOffset)*scaleBase/scale,
								((tempGUIObject.getFinalY()+cellHalfHeight+cellHeight*2)*flipUp+yFinalOffset)*scaleBase/scale,
								(child.getFinalX())*scaleBase/scale,
								(child.getFinalY())*scaleBase/scale);
						arrow.paint(g,30);		
					}
				}
			} else if (tempGUIObject.getPropertyString("Class").equals("javax.swing.JPopupMenu$Separator")){
				g.setColor(Color.green);
				g.drawString("separator",
						(tempGUIObject.getFinalX()+componentIndent+xFinalOffset)*scaleBase/scale,
						((tempGUIObject.getFinalY()+cellHeight*2)*flipUp+yFinalOffset)*scaleBase/scale);
				g.setColor(Color.black);
				/*g.drawLine((tempGUIObject.getFinalX()-rightOfVerticalLineSpace+xFinalOffset)*scaleBase/scale,
						((tempGUIObject.getFinalY()+cellHeight*2+cellHalfHeight)*flipUp+yFinalOffset)*scaleBase/scale,
						(tempGUIObject.getFinalX()+xFinalOffset)*scaleBase/scale,
						((tempGUIObject.getFinalY()+cellHeight*2+cellHalfHeight)*flipUp+yFinalOffset)*scaleBase/scale);*/
				
				
				g.drawRect((tempGUIObject.getFinalX()+componentIndent+xFinalOffset)*scaleBase/scale,
						((tempGUIObject.getFinalY()+cellHeight*3)*flipUp+yFinalOffset)*scaleBase/scale,
						cellWidth*scaleBase/scale,
						cellHeight*scaleBase/scale);
				
			} else if (!tempGUIObject.getType().equals("GUI")){
				if ((tempGUIObject.getPropertyString("Class").equals("javax.swing.JPanel"))&&
						tempGUIObject.getParent().getType().equals("GUI")){
					//ignored the first JPanel under a GUI
					// add more ignore statement here if NEEDED
				} else {
					isVisibleComponent=true;
					String type = tempGUIObject.getPropertyString("Type");
					
					/*
					 * 
					 */
					if (tempGUIObject.getParent().getType().equals("Menu")){
						
						/*if (tempGUIObject.getChildren().size() == 0){
							
							g.drawString(tempGUIObject.getPropertyString("Title"),
									(tempGUIObject.getFinalX()+componentIndent+xFinalOffset)*scaleBase/scale,
									((tempGUIObject.getFinalY()+cellHeight*2)*flipUp+yFinalOffset)*scaleBase/scale);
							// draw the little line in front of each menu|component
							g.drawLine((tempGUIObject.getFinalX()-rightOfVerticalLineSpace+xFinalOffset)*scaleBase/scale,
									((tempGUIObject.getFinalY()+cellHeight*2+cellHalfHeight)*flipUp+yFinalOffset)*scaleBase/scale,
									(tempGUIObject.getFinalX()+xFinalOffset)*scaleBase/scale,
									((tempGUIObject.getFinalY()+cellHeight*2+cellHalfHeight)*flipUp+yFinalOffset)*scaleBase/scale);
							
							
							g.drawRect((tempGUIObject.getFinalX()+componentIndent+xFinalOffset)*scaleBase/scale,
									((tempGUIObject.getFinalY()+cellHeight*3)*flipUp+yFinalOffset)*scaleBase/scale,
									cellWidth*scaleBase/scale,
									cellHeight*scaleBase/scale);
						}*/
						
						/*
						 * 	Need to draw the line between Menu/Component items
						 */
						
					} else {
						
						if ((tempGUIObject.getXOffset() > 0) && (tempGUIObject.getYOffset()>0)){
							
							if (enableComponent) {
								if (type != null && type.equals("TERMINAL"))
									g.setColor(Color.pink);
								else
									g.setColor(Color.black);
								
								g.drawRect((tempGUIObject.getFinalX()+xFinalOffset)*scaleBase/scale,
										(tempGUIObject.getFinalY()+yFinalOffset)*scaleBase/scale,
										(tempGUIObject.getXOffset())*scaleBase/scale,
										(tempGUIObject.getYOffset())*scaleBase/scale);
								String replayFlagString = tempGUIObject.getPropertyString("ReplayableAction");
								if (replayFlagString !=null && !replayFlagString.equals("")){
									g.drawString(tempGUIObject.getPropertyString("Title"),
										(tempGUIObject.getFinalX()+xFinalOffset)*scaleBase/scale,
										(tempGUIObject.getFinalY()+yFinalOffset)*scaleBase/scale);
								}
							} else {
								//do nothing?
							}
						} else {
							if (tempGUIObject.getParent().getPropertyString("Title").equals("Open_10")){
								//System.out.println("Poster:Update:drawEFG:"+tempGUIObject.getPropertyString("Title")+":"+tempGUIObject.getXOffset()+":"+tempGUIObject.getYOffset());
							}
							isVisibleComponent = false;
						}
						/*
						 if (isPrinted == false){
						 System.out.println(tempGUIObject.getPropertyString("Title"));
						 System.out.println("\t"+tempGUIObject.getFinalX()+":"+tempGUIObject.getX());
						 System.out.println("\t"+tempGUIObject.getFinalY()+":"+tempGUIObject.getY());
						 System.out.println("\t"+tempGUIObject.getXOffset()+":"+tempGUIObject.getYOffset());
						 }
						 */
					}
					
					Vector children=tempGUIObject.getChildren();
					GUIObject child;
					String invoke;
					/*
					 for (int j=0;j<children.size();j++){
					 child=(GUIObject)children.elementAt(j);
					 if (child.getType().equals("Menu") ||
					 child.getType().equals("GUI")){
					 g.drawLine(tempGUIObject.getFinalX(),
					 tempGUIObject.getFinalY(),
					 child.getFinalX(),
					 child.getFinalY());		
					 }
					 }
					 */
					
					if (isVisibleComponent == true){
						/*
						 if (tempGUIObject.getParent().getPropertyString("Title").equals("Open_10")){
						 System.out.println("Poster:Update:drawEFG:Visible:"+tempGUIObject.getPropertyString("Title"));
						 }
						 */
						
						children=tempGUIObject.getInvokeList();
						for (int j=0;j<children.size();j++){
							child=(GUIObject)GUIMap.get((String)children.elementAt(j));
							if (child.getType().equals("GUI") && enableInvokelink){					
								SimpleArrow arrow = new SimpleArrow((tempGUIObject.getFinalX()+xFinalOffset)*scaleBase/scale,
										(tempGUIObject.getFinalY()+yFinalOffset)*scaleBase/scale,
										(child.getFinalX())*scaleBase/scale,
										(child.getFinalY())*scaleBase/scale);
								arrow.paint(g,30);
							}
						}
						if ((enableEFG==true ||tempGUIObject.isEFGEnabled() == true) 
								&& enableComponent && eventGraph.isValid()){
							
							if (type != null && type.equals("TERMINAL"))
								g.setColor(Color.pink);
							else
								g.setColor(Color.red);
							children = tempGUIObject.getOutgoingEFG();
							int xStart=0, yStart=0, xEnd=0, yEnd=0;
							for (int j=0;j<children.size();j++){
								child=(GUIObject)children.elementAt(j);
								if ((child != tempGUIObject)&&(child.getXOffset()>0)&&(child.getYOffset()>0)){
									
									/*g.drawRect((tempGUIObject.getFinalX()+xFinalOffset)*scaleBase/scale,
											(tempGUIObject.getFinalY()+yFinalOffset)*scaleBase/scale,
											(tempGUIObject.getXOffset())*scaleBase/scale,
											(tempGUIObject.getYOffset())*scaleBase/scale);
									*/
									if (!tempGUIObject.getPropertyString("Class").equals("javax.swing.JMenuItem")&&
										!(tempGUIObject.getPropertyString("Class").equals("javax.swing.JMenu") &&
										tempGUIObject.getParent().getPropertyString("Class").equals("javax.swing.JMenu"))){
										xStart=tempGUIObject.getFinalX()+xFinalOffset;
										yStart=tempGUIObject.getFinalY()+yFinalOffset;
									} else {
										xStart=tempGUIObject.getFinalX()+cellWidth+componentIndent+xFinalOffset;
										yStart=(tempGUIObject.getFinalY()+cellHalfHeight+cellHeight*2)*flipUp+yFinalOffset;
									}
									if (!child.getPropertyString("Class").equals("javax.swing.JMenuItem")){
										xEnd=child.getFinalX()+child.getWindow().getFinalX();
										yEnd=child.getFinalY()+child.getWindow().getFinalY();
									} else {
										xEnd=child.getFinalX()+cellWidth+componentIndent+child.getWindow().getFinalX();
										yEnd=(child.getFinalY()+cellHalfHeight+cellHeight*2)*flipUp+child.getWindow().getFinalY();
									}
									if ((xStart<westPixel) || (yStart<northPixel) || (xEnd <westPixel) || (yEnd <northPixel)){
										/*
										 System.out.println("Poster:update:EFG edge:" +
										 tempGUIObject.getRoot().getPropertyString("Title")+":"+
										 tempGUIObject.getPropertyString("Title")+"|"+
										 child.getRoot().getPropertyString("Title")+":"+
										 child.getPropertyString("Title"));
										 */
									}else {
										SimpleArrow arrow = new SimpleArrow(xStart*scaleBase/scale,yStart*scaleBase/scale,xEnd*scaleBase/scale,yEnd*scaleBase/scale);
										arrow.paint(g,20);
									}
								}
							}
							g.setColor(Color.black);
						}
					}
				}
				
			} else if(tempGUIObject.getType().equals("Menu")){
				if (tempGUIObject.getParent().getType().equals("GUI")){
					
				} else if (tempGUIObject.getParent().getParent().getParent().getType().equals("Component")){
					// this should be done the same way leaf component is treated
					// wrtie the menu name
					g.drawString(tempGUIObject.getPropertyString("Title"),
							(tempGUIObject.getFinalX()+componentIndent+xFinalOffset)*scaleBase/scale,
							((tempGUIObject.getFinalY()+cellHeight*2)*flipUp+yFinalOffset)*scaleBase/scale);
					// draw the horizontal line in front of the menu
					g.drawLine((tempGUIObject.getFinalX()-rightOfVerticalLineSpace+xFinalOffset)*scaleBase/scale,
							((tempGUIObject.getFinalY()+cellHeight*2+cellHalfHeight)*flipUp+yFinalOffset)*scaleBase/scale,
							(tempGUIObject.getFinalX()+xFinalOffset)*scaleBase/scale,
							((tempGUIObject.getFinalY()+cellHeight*2+cellHalfHeight)*flipUp+yFinalOffset)*scaleBase/scale);
					// draw box around the fields			
					g.drawRect((tempGUIObject.getFinalX()+componentIndent+xFinalOffset)*scaleBase/scale,
							((tempGUIObject.getFinalY()+cellHeight*3)*flipUp+yFinalOffset)*scaleBase/scale,
							cellWidth*scaleBase/scale,
							cellHeight*scaleBase/scale);
					//extra stuff for menu
					//end of field extension the the sub menu
					g.drawLine((tempGUIObject.getFinalX()+cellWidth+componentIndent+xFinalOffset)*scaleBase/scale,
							((tempGUIObject.getFinalY()+cellHeight*2+cellHalfHeight)*flipUp+yFinalOffset)*scaleBase/scale,
							(tempGUIObject.getFinalX()+cellWidth+leftOfVerticalLineSpace+xFinalOffset)*scaleBase/scale,
							((tempGUIObject.getFinalY()+cellHeight*2+cellHalfHeight)*flipUp+yFinalOffset)*scaleBase/scale);
					//the vertical line connecting all sub menus
					g.drawLine((tempGUIObject.getFinalX()+cellWidth+leftOfVerticalLineSpace+xFinalOffset)*scaleBase/scale,
							((tempGUIObject.getFinalY()+cellHeight*2+cellHalfHeight)*flipUp+yFinalOffset)*scaleBase/scale,
							(tempGUIObject.getFinalX()+cellWidth+leftOfVerticalLineSpace+xFinalOffset)*scaleBase/scale,
							((tempGUIObject.getFinalY()+cellHeight+cellHalfHeight+(tempGUIObject.getChildren().size())*cellHeight)*flipUp+yFinalOffset)*scaleBase/scale);								
				} else if (tempGUIObject.getParent().getType().equals("Component")){
					/*
					 System.out.println("BBBGGG:"+tempGUIObject.getPropertyString("Title")+"|"+
					 tempGUIObject.getFinalX()+":"+
					 tempGUIObject.getFinalY()+":"+
					 tempGUIObject.getXOffset()+":"+
					 tempGUIObject.getYOffset());
					 */
					g.drawString(tempGUIObject.getPropertyString("Title"),
							(tempGUIObject.getFinalX()+xFinalOffset)*scaleBase/scale,
							((tempGUIObject.getFinalY()+cellHeight)*flipUp+yFinalOffset)*scaleBase/scale);
					//draw vertical line connecting menu components
					g.drawLine((tempGUIObject.getFinalX()-rightOfVerticalLineSpace+xFinalOffset)*scaleBase/scale,
							(tempGUIObject.getFinalY()+yFinalOffset)*scaleBase/scale,
							(tempGUIObject.getFinalX()-rightOfVerticalLineSpace+xFinalOffset)*scaleBase/scale,
							((tempGUIObject.getFinalY()+cellHeight+cellHalfHeight+(tempGUIObject.getChildren().size())*12)*flipUp+ yFinalOffset)*scaleBase/scale);						
				}
				
			}else if (tempGUIObject.getType().equals("GUI")){
			}else {
				System.out.println("Error: Wrong type"+tempGUIObject.getType()+":"+tempGUIObject.getPropertyString("Title"));
			}
			// draw line between windows
			
		}
		isPrinted=true;
		//set dynamic preferred size
		
		int scaledWidth = (eastPixel-westPixel)*scaleBase/scale;
		int scaledHeight = (southPixel-northPixel)*scaleBase/scale;
		
		setPreferredSize(new Dimension(scaledWidth,scaledHeight));
		//System.out.println("BBBGGG:Preferred size:"+(east-west)+"x"+(south-north));
		
		//g.translate(west,north);
		if (overview != null) {
			overview.validate();
			overview.repaint();
		}
		//graph.drawImage(offImage,0,0,this);
	}
	
	Vector findChildrenRecursive(GUIObject root, Coordinate coord, GUIObject guiRoot,int x, int y){
		Vector guiList = new Vector();
		GUIObject child;
		Vector children;
		/*
		 if ((root.getPropertyString("Title").equals("Word Count..._0")) || (root.getPropertyString("Title").equals("Justification_0"))){
		 System.out.println("Inside findChildrenRecursive:"+root.getPropertyString("Title")+":"+x+":"+y);
		 }
		 */
		//if (root.getPropertyString("Title").equals("Open_1"))
		//System.out.println("BBBGGGy:"+root.getPropertyString("Title")+":"+root.getType());
		//System.out.println("BBBGGGy:"+root.getPropertyString("Title")+":"+guiRoot.getPropertyString("Title"));
		if (root.getType().equals("GUI")){
			//System.out.println("\tBBBGGGb:"+root.getPropertyString("Title"));
			children = root.getChildren();
			for (int i = 0; i < children.size(); i++ ) {
				child = (GUIObject) children.elementAt(i);
				guiList.addAll(findChildrenRecursive(child,coord,root,x,y));
				/*
				 if (child.getType().equals("Component")) {
				 guiList.addAll(findChildrenRecursive(child,coord,root,x,y));
				 } else { // Menu
				 guiList.addAll(findChildrenRecursive(child,coord,root,x,y));
				 }
				 */
			}
			
			// record the current x and y max
			coord.setMaxX(root.getXOffset());
			coord.setMaxY(root.getYOffset());
			
			// set the image
			//String imageFileNameString=root.getPropertyString("JPEG");
			root.setImage(imageDirectory,url);
			//TODO huh?
			//} else if (root.getType().equals("Component")){
		} else if (root.getType().equals("Container")){
			if (root.getPropertyString("Class").equals("javax.swing.JMenu") ||
			    root.getPropertyString("Class").equals("rath.jmsn.ui.WrapMenu")){
				//TODO
				
				if (root.getParent().getPropertyString("Class").equals("javax.swing.JMenu") ||
				    root.getParent().getPropertyString("Class").equals("rath.jmsn.ui.WrapMenu")) {
					//System.out.println("Set submenu "+root.getPropertyString("Title"));
					root.setFinalX(x);
					root.setFinalY(y);
					coord.setMaxX(x+cellWidth);
					coord.setMaxY(y+cellHeight);
				} else {
					
					root.setFinalX(root.getX());
					root.setFinalY(root.getY());
					//root.setWindow(guiRoot);
				}
				children = root.getChildren();
				for (int i= 0; i < children.size();i++){
					child = (GUIObject) children.elementAt(i);
					guiList.addAll(findChildrenRecursive(child,coord,guiRoot,x+cellWidth+treeSpace,y+cellHeight*i));
				}	
				
			} else if (root.getPropertyString("Class").equals("javax.swing.JMenuBar")||
				root.getPropertyString("Class").equals("rath.jmsn.MSNMenuBar") ||
				root.getPropertyString("Class").equals("freemind.controller.MenuBar") ){
				//TODO
				children = root.getChildren();
				
				root.setFinalX(root.getX());
				root.setFinalY(root.getY());
				//root.setWindow(guiRoot);
				
				for (int i=0;i< children.size();i++) {
					child = (GUIObject) children.elementAt(i);
					//all child should be components
					//maxX is not getting updated
					//System.out.println("BBBGGG: "+child.getPropertyString("Title")+":"+(coord.getMaxX()+30)+":"+y);
					guiList.addAll(findChildrenRecursive(child,coord,guiRoot,coord.getMaxX()+treeSpace,y));
					//coord.setX(coord.getMaxX()+30);
				}
			} else {
				//regular container
				root.setFinalX(root.getX());
				root.setFinalY(root.getY());
				//root.setWindow(guiRoot);
				children = root.getChildren();
				for (int i = 0; i < children.size(); i++) {
					child = (GUIObject) children.elementAt(i);
					//System.out.println("What the fuck "+i);
					guiList.addAll(findChildrenRecursive(child,coord,guiRoot,x,y));
				}	
			}
		} else if (root.getType().equals("Widget")){
			if (root.getPropertyString("Class").equals("javax.swing.JMenuItem") ||
				root.getPropertyString("Class").equals("javax.swing.JCheckBoxMenuItem") ||
				root.getPropertyString("Class").equals("javax.swing.JRadioButtonMenuItem") ||
				root.getPropertyString("Class").equals("javax.swing.JMenu$1") ||
				root.getPropertyString("Class").equals("rath.jmsn.ui.WrapMenuItem")){
				//MenuItem					
				root.setFinalX(x);
				root.setFinalY(y);
				//root.setWindow(guiRoot);
				coord.setMaxX(x+cellWidth);
				coord.setMaxY(y+cellHeight);
				if (root.getInvokeList().size() > 0)
					guiList.addAll(root.getInvokeList());
			} else if (root.getPropertyString("Class").equals("javax.swing.JPopupMenu$Separator")){
				root.setFinalX(x);
				root.setFinalY(y);
				//root.setWindow(guiRoot);
				coord.setMaxX(x+cellWidth);
				coord.setMaxY(y+cellHeight);
			} else if (root.getPropertyString("Class").equals("javax.swing.JMenu") || 
				root.getPropertyString("Class").equals("rath.jmsn.ui.WrapMenu")) {
				if (root.getParent().getPropertyString("Class").equals("javax.swing.JMenu") ||
				    root.getParent().getPropertyString("Class").equals("rath.jmsn.ui.WrapMenu")) {
					root.setFinalX(x);
					root.setFinalY(y);
					coord.setMaxX(x+cellWidth);
					coord.setMaxY(y+cellHeight);
				} else {
					root.setFinalX(root.getX());
					root.setFinalY(root.getY());
				}
				//System.out.println("BBBGGGx:"+root.getPropertyString("Title")+":"+guiRoot.getPropertyString("Title"));
			} else {
				//System.out.println(root.getPropertyString("Class")+":"+guiRoot.getPropertyString("Title"));
				//System.out.println("Hello");
				root.setFinalX(root.getX());
				root.setFinalY(root.getY());
				//root.setWindow(guiRoot);
				//System.out.println("BBBGGGx:"+root.getPropertyString("Title")+":"+guiRoot.getPropertyString("Title"));
				if (root.getInvokeList().size() > 0) 
					guiList.addAll(root.getInvokeList());
			}
			/*} else if (root.getParent().getParent().getType().equals("GUI")) {
			 // GUI->Menu->Component <---- this
			  // should only be the end leaf or contain one element Menu
			   children = root.getChildren();
			   root.setRoot(guiRoot);
			   if (children.size() == 1) {
			   child = (GUIObject) children.elementAt(0);
			   if ( child.getType().equals("Menu")) {
			   // we ignore this type of component position
			    guiList.addAll(findChildrenRecursive(child,coord,guiRoot,x,y));
			    coord.setMaxX(x+cellWidth);
			    } else {
			    System.out.println("Error, Menu type expected");
			    }
			    } else {
			    System.out.println("Error: "+root.getPropertyString("Title")+" has more than one child");
			    }
			    } else {
			    // ..->Component->Menu->Component <---- this
			     children = root.getChildren();
			     if (children.size() == 0) {
			     // leaf node copied
			      root.setFinalX(x);
			      root.setFinalY(y);
			      root.setRoot(guiRoot);
			      coord.setMaxX(x+cellWidth);
			      coord.setMaxY(y+cellHeight);
			      if (root.getInvokeList().size() > 0)
			      guiList.addAll(root.getInvokeList());
			      } else if ( children.size() == 1) {
			      // this should be a Menu Node
			       //..->Component->Menu->Component(<---this)-->Component
			        root.setFinalX(x);
			        root.setFinalY(y);
			        root.setRoot(guiRoot);
			        child = (GUIObject) children.elementAt(0);
			        if (child.getType().equals("Menu")) {
			        //extended Menu
			         guiList.addAll(findChildrenRecursive(child,coord,guiRoot,x,y));
			         //System.out.println(coord.getMaxX()+":"+x);
			          coord.setMaxX(x+cellWidth);
			          //System.out.println(coord.getMaxX()+":"+x);
			           } else {
			           System.out.println("Error: Menu expected");
			           }
			           } else {
			           System.out.println("Error: Component should not have multiple children");
			           }*/
			
		}
/* 
		else if (root.getType().equals("Menu")) {
			//menu supposed only have a list of components
			if (root.getParent().getType().equals("GUI")) {
				//first one, display horizontally
				//GUI->Menu copied
				
				children = root.getChildren();
				
				root.setFinalX(x);
				root.setFinalY(y);
				//root.setWindow(guiRoot);
				
				for (int i=0;i< children.size();i++) {
					child = (GUIObject) children.elementAt(i);
					//all child should be components
					//maxX is not getting updated
					//System.out.println("BBBGGG: "+child.getPropertyString("Title")+":"+(coord.getMaxX()+30)+":"+y);
					guiList.addAll(findChildrenRecursive(child,coord,guiRoot,coord.getMaxX()+treeSpace,y));
					//coord.setX(coord.getMaxX()+30);
				}
			} else if (root.getParent().getParent().getParent().getType().equals("Component")){
				//Component->Menu->Component->Menu(<--This)
				children = root.getChildren();
				root.setFinalX(x);
				root.setFinalY(y);
				//root.setWindow(guiRoot);
				
				for (int i= 0; i < children.size();i++){
					child = (GUIObject) children.elementAt(i);
					guiList.addAll(findChildrenRecursive(child,coord,guiRoot,x+cellWidth+treeSpace,y+cellHeight*i));
				}
				
				
			} else {
				
				// inner one, display vertically
				//GUI->Menu->Component
				children = root.getChildren();
				root.setFinalX(x);
				root.setFinalY(y);
				//root.setWindow(guiRoot);
				coord.setMaxX(x+cellWidth);
				coord.setMaxY(y+cellHeight);
				
				for (int i=0;i< children.size();i++) {
					child = (GUIObject) children.elementAt(i);
					guiList.addAll(findChildrenRecursive(child,coord,guiRoot,x,y+cellHeight*i));
						//coord.setY(coord.getY()+12);
				}
				//coord.setMaxX(x+cellWidth);
				//coord.setMaxY(y);
				
			}
		}
*/
		return guiList;
	}
		
	
	/*public void showComponentProperty(GUIObject currentGUIObject) {
		final JDialog d = new JDialog();
		d.setTitle("Widget Inspector");
		String GUIType=currentGUIObject.getType();
		
		JPanel dialogContent = new JPanel();	
		JScrollPane jScroll;
		
		HashMap properties = currentGUIObject.getHashedProperties();
		int propertySize = properties.size();
		
		dialogContent.setLayout(new GridLayout(propertySize+5,2));
		dialogContent.add(new JLabel("Title"));
		dialogContent.add(new JLabel(currentGUIObject.getPropertyString("Title")));
		
		dialogContent.add(new JLabel("Root GUI"));
		dialogContent.add(new JLabel((String)currentGUIObject.getWindow().getPropertyString("Title")));
		
		Iterator iter = properties.keySet().iterator();
		int i=1;
		String propertyName;
		Object propertyValueObject;
		while (iter.hasNext() == true){
			propertyName = (String) iter.next();
			
			
			
			 * We don't want to see title for the second time
			 
			if (!propertyName.equals("Title")){
				dialogContent.add(new JLabel(propertyName));
				propertyValueObject = properties.get(propertyName);
				if (propertyValueObject instanceof String)
					dialogContent.add(new JLabel((String) properties.get(propertyName)));
				else if (propertyValueObject instanceof Vector){
					Vector propertyValueVector = (Vector)propertyValueObject;
					String propertyValueString = "";
					for (int j=0; j< propertyValueVector.size();j++){
						if (j==0)
							propertyValueString += (String) propertyValueVector.elementAt(j);
						else
							propertyValueString += ","+(String) propertyValueVector.elementAt(j);
					}
					dialogContent.add(new JLabel(propertyValueString));
				}
				i++;					
			}
			
		}
		
		dialogContent.add(new JLabel("Width"));
		dialogContent.add(new JLabel(""+currentGUIObject.getXOffset()));
		
		dialogContent.add(new JLabel("Height"));
		dialogContent.add(new JLabel(""+currentGUIObject.getYOffset()));
		
		
		dialogContent.add(new JLabel("X"));
		dialogContent.add(new JLabel(""+currentGUIObject.getX()));
		
		dialogContent.add(new JLabel("Y"));
		dialogContent.add(new JLabel(""+currentGUIObject.getY()));
		
		int v=ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED;
		int h=ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED;
		jScroll= new JScrollPane(dialogContent,v,h);
		
		JButton b = new JButton("Close Window");
		
		b.addActionListener(new ActionListener() {
			public void actionPerformed (ActionEvent ev) {
				d.setVisible(false);
				d.dispose();
			}
		});
		
		JButton jbEFG;
		if (currentGUIObject.isEFGEnabled()==false){
			jbEFG = new JButton("Enable EFG");
			jbEFG.addActionListener(new ActionListener() {
				public void actionPerformed (ActionEvent ev) {
					currentGUIObject.setEFGEnabled(true);
					//update();
				}
			});
		} else {
			jbEFG = new JButton("Disable EFG");
			jbEFG.addActionListener(new ActionListener() {
				public void actionPerformed (ActionEvent ev) {
					//currentGUIObject.setEFGEnabled(false);
					//update();
				}
			});
			
		}
		
		
		//dialogContent.add(b);
		
		d.getContentPane().add(jScroll,BorderLayout.CENTER);
		JPanel buttonPanel = new JPanel();
		buttonPanel.add(b);
		buttonPanel.add(jbEFG);
		d.getContentPane().add(buttonPanel,BorderLayout.SOUTH);
		
		Dimension dim = d.getPreferredSize();
		int x = (int) Math.round(dim.getWidth());
		int y = (int) Math.round(dim.getHeight());
		x=x+10;
		if (x > 300)
			x=300;
		y=30*(propertySize+4);
		if (y > 300)
			y=300;
		d.setSize(x,y);
		d.setVisible(true);
		
	}*/
	
	private void calculateSize(){
		eastPixel=0;
		westPixel=0;
		southPixel=0;
		northPixel=0;
		GUIObject tempGUIObject;
		for (int i=0;i<allGUIObject.size();i++){
			/*  this loop only do GUI type
			 *  Reason: need to draw the jpg image first,
			 * 	then over lay the rect and string
			 */  
			tempGUIObject=(GUIObject)allGUIObject.elementAt(i);
			if (tempGUIObject.getType().equals("GUI")){
				/*	
				 * 
				 
				 System.out.println((int)i+"|"+
				 tempGUIObject.getPropertyString("Title")+":"+
				 tempGUIObject.getFinalX()+":"+
				 tempGUIObject.getFinalY()+":"+
				 tempGUIObject.getXOffset()+":"+
				 tempGUIObject.getYOffset());
				 */
				
				/* 
				 * calculate the east, west, south, north boundary
				 */
				if (eastPixel<tempGUIObject.getFinalX()+tempGUIObject.getXOffset())
					eastPixel =tempGUIObject.getFinalX()+tempGUIObject.getXOffset();
				if (southPixel<tempGUIObject.getFinalY()+tempGUIObject.getYOffset())
					southPixel =tempGUIObject.getFinalY()+tempGUIObject.getYOffset();
				if (northPixel > tempGUIObject.getFinalY())
					northPixel = tempGUIObject.getFinalY();
				if (westPixel >tempGUIObject.getFinalX())
					westPixel = tempGUIObject.getFinalX();
				
			}
		}
		/*
		 System.out.println("Poster:calculateSize():Left Boundary:"+westPixel);
		 System.out.println("Poster:calculateSize():Right Boundary:"+eastPixel);
		 System.out.println("Poster:calculateSize():Top Boundary:"+northPixel);
		 System.out.println("Poster:calculateSize():Bottom Boundary:"+southPixel);
		 */	
	}
	public Dimension getOverallSize(){
		
		return new Dimension(eastPixel-westPixel, southPixel-northPixel);
		
	}
	/*
	 * get and set poster display property
	 * @author bingan
	 *
	 * To change the template for this generated type comment go to
	 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
	 */
	public boolean isEFGDisplay(){
		return enableEFG;
	}
	public boolean isGraphDisplay(){
		return showGraphics;
	}
	public boolean isComponentDisplay(){
		return enableComponent;
	}
	
	public boolean isInvokelinkDisplay(){
		return enableInvokelink;
	}
	
	public void setEFGDisplay(boolean status){
		enableEFG = status;
	}
	public void setGraphDisplay(boolean status){
		showGraphics = status;
	}
	public void setComponentDisplay(boolean status){
		enableComponent = status;
	}
	
	public void setInvokelinkDisplay(boolean status) {
		enableInvokelink = status;
	}
	public Vector getAllObject(){
		return allGUIObject;
	}
}
