import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Random;
import java.util.Set;
import java.util.Vector;

/*
 * Created on May 5, 2005
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
/**
 * @author bingan
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class StructuralTestCaseGenerator {
	EventGraph eventGraph;
	HashMap windowComponentMap=new HashMap();
	private int testCaseID=0;
	StructuralTestCaseGenerator(EventGraph eventGraph){
		GUIObject eventObject,windowObject,baseWindowObject;
		String windowLabelString;
		this.eventGraph=eventGraph;
		for (int i= 0; i < this.eventGraph.getEGSize();i++){
			eventObject = eventGraph.getEvent(i).getEventObject();
			windowObject = eventObject.getWindow();
			baseWindowObject = windowObject.getBaseWindow();
			if (baseWindowObject.getPropertyString("Rootwindow").equals("true")){
				windowLabelString = "Rootwindow";			
			} else {
				windowLabelString = baseWindowObject.getPropertyString("Title");
			}
			Vector windowComponentVector=(Vector) windowComponentMap.get(windowLabelString);
			if (windowComponentVector==null){
				windowComponentVector=new Vector();
				windowComponentVector.add(new Integer(i));
				windowComponentMap.put(windowLabelString,windowComponentVector);
			} else {
				windowComponentVector.add(new Integer(i));
			}
		}
	}
	private int getID(){
		int returnID = testCaseID;
		testCaseID++;
		return returnID;
	}
	private void resetIDCounter(){
		testCaseID=0;
	}
	public String[] getWindowLabelStrings() {
		Set windowLabelSet = windowComponentMap.keySet();
		String windowLabels[];
		String windowLabel;
		
		if (windowLabelSet !=null){
			windowLabels = new String[windowLabelSet.size()];
			Iterator iterator = windowLabelSet.iterator();
			for (int i=0; i< windowLabelSet.size();i++){
				windowLabel=(String) iterator.next();
				windowLabels[i]=windowLabel;
			}
			return windowLabels;
		}
		return null;
	}
	
	public void generateRandom(File directory, int testcaseLength, int testcaseNumber, String windowLabelString){
		int eventID;
		File testcaseDirectory,testcaseFile;
		GUIEvent event;
		GUIObject eventObject,eventWindow=null;
		Vector windowComponentVector = (Vector) windowComponentMap.get(windowLabelString);
		
		
		if (windowComponentVector == null)
			return;
		
		int componentSize=windowComponentVector.size();
		
		Random randomNumberGenerator = new Random();
		if ((directory == null) || directory.isDirectory()== false){
			testcaseDirectory = new File(System.getProperty("user.dir"));
		} else {
			testcaseDirectory = directory;
		}
		try {
			for (int i=0; i< testcaseNumber;i++){
				testcaseFile = new File(testcaseDirectory,getID()+".tst");
				FileWriter writer = new FileWriter(testcaseFile);
				writer.write("<Testcase>\n");
				int j=0;
				do {
					int eventVectorIndex=randomNumberGenerator.nextInt(componentSize);
					eventID = ((Integer)windowComponentVector.elementAt(eventVectorIndex)).intValue();
					event = eventGraph.getEvent(eventID);
					eventObject= event.getEventObject();
					
					String typeString = eventObject.getPropertyString("Type");
					eventWindow = eventObject.getInvokeeObject();
					if (typeString == null ||	 
							!typeString.equals("Terminal")||	 
							j== testcaseLength-1||
							eventWindow == null){
						eventWindow = eventObject.getBaseWindow();
						writer.write("\n");
						writer.write(event.stepToStringWithIndentation(eventObject,0,eventWindow));
						//System.out.println(event.stepToStringWithIndentation(eventObject,0,eventWindow)+"\n");
						j++;
					} 
				}while (j<testcaseLength);
				writer.write("</Testcase>\n");
				writer.close();
			}
		} catch (IOException e){
			e.printStackTrace();
		}
		
	}
	public void generateSequential(File directory, 
									int testcaseLength, 
									int testcaseNumber,
									String windowLabelString,
									boolean isGenerateAll){
		int toGenerate=testcaseNumber,eventID;
		GUIEvent event;
		GUIObject eventObject;
		String testNamePrefixString;
		Vector windowComponentVector = (Vector) windowComponentMap.get(windowLabelString);
		if (windowComponentVector == null)
			return;
		int iSeparatorIndex=windowLabelString.lastIndexOf("_");
		if (iSeparatorIndex != -1)
			testNamePrefixString="E"+windowLabelString.substring(iSeparatorIndex+1)+"_"+testcaseLength+"_";
		else
			testNamePrefixString="E0_"+testcaseLength+"_";
		int componentSize=windowComponentVector.size();
		Vector nonTerminalVector = new Vector();
		for (int i=0; i< componentSize;i++){
			eventID = ((Integer)windowComponentVector.elementAt(i)).intValue();
			event = eventGraph.getEvent(eventID);
			eventObject= event.getEventObject();
			if (!eventObject.getPropertyString("Type").equals("Terminal") &&
					eventObject.getInvokeeObject()==null)
				nonTerminalVector.add(windowComponentVector.elementAt(i));
		}
		toGenerate = generateSequentialWithLevel(directory,
				testcaseLength, 
				nonTerminalVector,
				windowComponentVector,
				new Vector(),
				toGenerate,
				testNamePrefixString,
				isGenerateAll);
		if (toGenerate >0)
			System.out.println("Opps, try to create more than possible");
	}
	private int generateSequentialWithLevel( File testcaseDirectory, 
											int level, 
											Vector nonTerminalVector,
																Vector allWidgetVector,
																	Vector currentStepVector,
		int toGenerate,
		String testNamePrefixString,
		boolean isGenerateAll){
		if (level == 1) {
			for (int i=0; i< allWidgetVector.size() && (isGenerateAll || toGenerate >0) ;i++)
			{
				currentStepVector.add(allWidgetVector.elementAt(i));
				generateTestcaseFile(testcaseDirectory, currentStepVector,testNamePrefixString);
				toGenerate--;
				currentStepVector.remove(currentStepVector.size()-1);
			}
		} else {
			for (int i=0; i < nonTerminalVector.size() && (isGenerateAll || toGenerate >0);i++){
				
				currentStepVector.add(nonTerminalVector.elementAt(i));
				System.out.println("Hmm"+nonTerminalVector.elementAt(i));
				toGenerate=generateSequentialWithLevel(testcaseDirectory,
						level-1,
						nonTerminalVector,
						allWidgetVector,
						currentStepVector,
						toGenerate,
						testNamePrefixString,
						isGenerateAll);
				currentStepVector.remove(currentStepVector.size()-1);
			}
		}
		return 0;
	}
	private void generateTestcaseFile(File directory, Vector currentStepVector,String testNamePrefixString){
		File testcaseFile,testcaseDirectory;
		System.out.println(directory);
		try {
			if ((directory == null) || directory.isDirectory()== false){
				testcaseDirectory = new File(System.getProperty("user.dir"));
			} else {
				testcaseDirectory = directory;
			}
			
			testcaseFile = new File(testcaseDirectory,testNamePrefixString+getID()+".tst");
			System.out.println(testcaseFile);
			FileWriter writer = new FileWriter(testcaseFile);
			writer.write("<Testcase>\n");
			GUIEvent event;
			GUIObject eventObject,eventWindowResult=null;
			for (int j=0; j<currentStepVector.size();j++){
				//System.out.print("Hello"+(Integer)currentStepVector.elementAt(j));
				event = eventGraph.getEvent(((Integer)currentStepVector.elementAt(j)).intValue());
				System.out.println(event==null);
				eventObject=event.getEventObject();
				writer.write(event.stepToStringWithIndentation(eventObject,0,eventWindowResult));
				writer.write("\n");
				
				eventWindowResult = eventObject.getInvokeeObject();
				if (eventWindowResult == null)
					eventWindowResult =eventObject.getBaseWindow();
				
			}
			/*event = efg.getEvent(i);
			 eventObject=event.getEventObject();
			 writer.write(event.stepToStringWithIndentation(eventObject,0,eventWindowResult));*/
			writer.write("</Testcase>\n");
			writer.close();
		} catch (IOException e){
			e.printStackTrace();
		}
	}
	public void debugInfo(){
		String[] windowLabels = getWindowLabelStrings();
		if (windowLabels!=null){
			for (int i=0;i< windowLabels.length;i++){
				System.out.println(i+":"+windowLabels[i]);
			}
		}
	}
	public void generateAllByLength(File directory, int testcaseLength){
		String[] allWindowLabelStrings = getWindowLabelStrings();
		for (int i =0; i < allWindowLabelStrings.length;i++){
			resetIDCounter();
			generateSequential(directory,
					testcaseLength,
					0,
					allWindowLabelStrings[i],
					true);
		}
	}
	private static void printUsage() {
		System.out.println("usage: Java StructuralTestCaseGenerator -options\n");
		System.out.println("where options include:");
		System.out.println("\t-r|--random");
		System.out.println("\t-s|--sequential");
		System.out.println("\t-n|--number          <number of test case to generate, 0 for all>");
		System.out.println("\t-w|--window          <window name, if not provided, use all window>");
		System.out.println("\t                     random has to provide window name.");
		System.out.println("\t-l|--length          <length of the test cases>");
		System.out.println("\t-g|--gui             <GUI file to use>");
		System.out.println("\t-e|--eventgraph      <event graph file to use>");
		System.out.println("\t-d|--targetDirectory <place to hold the test cases>");
		System.out.println("\nNote: you have to pick either -r or -s, not both, not neither.");
		System.out.println("    -n, -l -g options are required, -e is optional");
		System.out.println("    -e is optional, if omitted, a new EventGraph will be generated");
		System.out.println("    -d is optional, if omitted, a TC directory under current directory will be used");
		System.exit(2);
	}
	public static void main (String[] argv){
		CmdLineParser cmdLineParser = new CmdLineParser();

		CmdLineParser.Option oRandom = cmdLineParser.addBooleanOption('r',"random");
		CmdLineParser.Option oSequential = cmdLineParser.addBooleanOption('s',"sequential");
		CmdLineParser.Option oNumber = cmdLineParser.addIntegerOption('n',"number");
		CmdLineParser.Option oLength = cmdLineParser.addIntegerOption('l',"length");
		CmdLineParser.Option oGUI = cmdLineParser.addStringOption('g',"gui");
		CmdLineParser.Option oEventgraph = cmdLineParser.addStringOption('e',"eventgraph");
		CmdLineParser.Option oTargetDirectory = cmdLineParser.addStringOption('d',"targetDirectory");
		CmdLineParser.Option oWindowname = cmdLineParser.addStringOption('w',"window");


		Integer integerNumber, integerLength;
		String guiFileNameString, eventFileNameString,directoryNameString,windowString;

		try {
			cmdLineParser.parse(argv);
		} catch (CmdLineParser.OptionException e){
			printUsage();
		}

		Boolean isRandom, isSequential;
		isRandom = (Boolean)cmdLineParser.getOptionValue(oRandom);
		isSequential = (Boolean)cmdLineParser.getOptionValue(oSequential);

		boolean isAllWindow=false;
		boolean isEventGraphAvailable = true;
		windowString = (String)cmdLineParser.getOptionValue(oWindowname);	
		if (windowString == null)
			isAllWindow = true;

		if (isRandom == null && isSequential == null)
			printUsage();
		else if (isRandom != null && isSequential != null)
			printUsage();
		else if (isRandom != null && isAllWindow == true)
			printUsage();

		integerNumber = (Integer)cmdLineParser.getOptionValue(oNumber);
		integerLength = (Integer)cmdLineParser.getOptionValue(oLength);
		guiFileNameString = (String)cmdLineParser.getOptionValue(oGUI);
		if (integerNumber == null || integerLength == null || guiFileNameString == null)
			printUsage();

		eventFileNameString = (String)cmdLineParser.getOptionValue(oEventgraph);
		if (eventFileNameString == null)
			isEventGraphAvailable = false;

		directoryNameString = (String)cmdLineParser.getOptionValue(oTargetDirectory);
		if (directoryNameString == null)
			directoryNameString = System.getProperty("user.dir");


		try {
			
			GUIParser parser = new GUIParser(guiFileNameString, false, null);
			Vector allGUIObject = parser.getGUIObjects();
			EventGraph eventGraph;
			if (isEventGraphAvailable == true) {
				EventGraphReader eventGraphReader=new EventGraphReader(eventFileNameString,allGUIObject);
				if (eventGraphReader.isSuccess()) {
					eventGraph = eventGraphReader.getEventGraph();
				} else {
					System.out.println("Invalid event graph file, please check");
					return;
				}
			}
			else {
				EIG eig = new EIG();
				eig.generateEG(allGUIObject);
				eventGraph = eig.getEventGraph();
			}
			StructuralTestCaseGenerator testCaseGenerator = new StructuralTestCaseGenerator(eventGraph);
			testCaseGenerator.debugInfo();
			//testCaseGenerator.generateRandom(null,2,1,"Rootwindow");
			//testCaseGenerator.generateSequential(null,2,3,"Rootwindow");
			File testcaseDirectory = new File(directoryNameString);
			File directory = new File(testcaseDirectory,"TC");
			if (directory.exists())
				if (!directory.isDirectory()){
					directory.delete();
					directory.mkdir();
				} else {
				}
			else{
				directory.mkdir();
			}
			if (isRandom != null)
				testCaseGenerator.generateRandom(directory,
                                        integerLength.intValue(),
                                        integerNumber.intValue(),
					windowString);
			else if (isAllWindow == true)
				testCaseGenerator.generateAllByLength(
					directory,
					integerLength.intValue());
			else 
				testCaseGenerator.generateSequential(
					directory,
                                       	integerLength.intValue(),
                                       	integerNumber.intValue(),
                                       	windowString,
                                       	false);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
