import java.io.File;
import java.util.List;
import java.util.Vector;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

/*
 * Created on Apr 27, 2005
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
/**
 * @author bingan
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class TestCaseReader {
	final static int NULLVECTOR = -1;
	boolean isValid=false;
	Vector testStepVector=null;
	TestCaseReader(File testcaseFile){
		if (testcaseFile != null){
			testStepVector = new Vector();
			parseTestCase(testcaseFile);
		}
	}
	private void parseTestCase(File testcaseFile){
		try {
			SAXBuilder builder= new SAXBuilder();
			Document doc = builder.build(testcaseFile); 
			Element root = doc.getRootElement();
			Element property;
			List properties;
			String propertyName,propertyValue;
			
			List stepList = root.getChildren("Step");
			int stepVectorSize = stepList.size();
			
			for (int i=0; i < stepVectorSize; i++){
				Element stepElement = (Element)stepList.get(i);
				String window = stepElement.getChildText("Window");
				String component = stepElement.getChildText("Component");
				String action = stepElement.getChildText("Action");
				boolean isWindow;
				if ("true".equals(stepElement.getChildText("WindowFlag"))){
					isWindow=true;
				}else {
					isWindow=false;
				}
				TestStep testStep= new TestStep(window,component,action,isWindow);
				properties = stepElement.getChild("Attributes").getChildren("Property");
				for (int j=0; j< properties.size();j++){
					property = (org.jdom.Element) properties.get(j);
					//System.out.print("BBBGGG: "+property.getChildText("Name"));
					//System.out.println(" "+property.getChildText("Value"));
					propertyName = property.getChildText("Name");
					List propertyValueList = property.getChildren("Value");
					
					
						Vector propertyValueVector = new Vector();
						for (int k=0; k< propertyValueList.size();k++){
							propertyValue = ((Element)propertyValueList.get(k)).getValue();
							propertyValueVector.add(propertyValue);
						}
						testStep.setProperty(propertyName,propertyValueVector);						
				}
				testStepVector.add(testStep);
			}
			isValid = true;
		} catch (Exception e){
			e.printStackTrace();
		} 
	}
	public int getSize(){
		if (!isValid)
			return NULLVECTOR;
		return testStepVector.size();	
	}
	public TestStep getTestStep(int stepNumber){
		if ((!isValid) || (stepNumber <0) || (stepNumber>=testStepVector.size()))
			return null;
		else
			return (TestStep) testStepVector.elementAt(stepNumber);
	}
	public boolean isValid(){return isValid;}
	
	public static void main(String[] args){
		TestCaseReader testCaseReader = new TestCaseReader(new File("TC"+File.separator+"E0_2_1.tst"));
		if (testCaseReader.isValid()){
			int testSteps = testCaseReader.getSize();
			for (int i=0; i < testSteps;i++){
				System.out.println(testCaseReader.getTestStep(i));
			}
		}
		
	}
}
