import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;
/*
 * Created on May 18, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author bingan
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class WidgetInfo extends JDialog {
	GUIObject guiObject;
	JButton jbEFG;
	WidgetInfo(GUIObject targetObject) {
		guiObject = targetObject;
		
		setTitle("Widget Inspector");
		String GUIType=guiObject.getType();
		
		JPanel dialogContent = new JPanel();	
		JScrollPane jScroll;
		
		HashMap properties = guiObject.getHashedProperties();
		int propertySize = properties.size();
		
		dialogContent.setLayout(new GridLayout(propertySize+5,2));
		dialogContent.add(new JLabel("Title"));
		dialogContent.add(new JLabel(guiObject.getPropertyString("Title")));
		
		if (!"GUI".equals(GUIType)){
			dialogContent.add(new JLabel("Root GUI"));
			dialogContent.add(new JLabel((String)guiObject.getWindow().getPropertyString("Title")));
		}
		
		Iterator iter = properties.keySet().iterator();
		int i=1;
		String propertyName;
		Object propertyValueObject;
		while (iter.hasNext() == true){
			propertyName = (String) iter.next();
			
			
			/*
			 * We don't want to see title for the second time
			 */
			if (!propertyName.equals("Title")){
				dialogContent.add(new JLabel(propertyName));
				propertyValueObject = properties.get(propertyName);
				if (propertyValueObject instanceof String)
					dialogContent.add(new JLabel((String) properties.get(propertyName)));
				else if (propertyValueObject instanceof Vector){
					Vector propertyValueVector = (Vector)propertyValueObject;
					String propertyValueString = "";
					for (int j=0; j< propertyValueVector.size();j++){
						if (j==0)
							propertyValueString += (String) propertyValueVector.elementAt(j);
						else
							propertyValueString += ","+(String) propertyValueVector.elementAt(j);
					}
					dialogContent.add(new JLabel(propertyValueString));
				}
				i++;					
			}
			
		}
		
		dialogContent.add(new JLabel("Width"));
		dialogContent.add(new JLabel(""+guiObject.getXOffset()));
		
		dialogContent.add(new JLabel("Height"));
		dialogContent.add(new JLabel(""+guiObject.getYOffset()));
		
		
		dialogContent.add(new JLabel("X"));
		dialogContent.add(new JLabel(""+guiObject.getX()));
		
		dialogContent.add(new JLabel("Y"));
		dialogContent.add(new JLabel(""+guiObject.getY()));
		
		int v=ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED;
		int h=ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED;
		jScroll= new JScrollPane(dialogContent,v,h);
		
		JButton b = new JButton("Close Window");
		
		b.addActionListener(new ActionListener() {
			public void actionPerformed (ActionEvent ev) {
				setVisible(false);
				dispose();
			}
		});
		getContentPane().add(jScroll,BorderLayout.CENTER);
		JPanel buttonPanel = new JPanel();
		buttonPanel.add(b);
		
		
		String replayActionString = guiObject.getPropertyString("ReplayableAction");
		jbEFG=new JButton();
		boolean isEFGEnabled = guiObject.isEFGEnabled();
		if (isEFGEnabled==false){
			jbEFG.setText("Enable EFG");
		} else {
			jbEFG.setText("Disable EFG");
		}
		jbEFG.addActionListener(new ActionListener() {
			public void actionPerformed (ActionEvent ev) {
				boolean isEFGEnabled = guiObject.isEFGEnabled();
				guiObject.setEFGEnabled(!isEFGEnabled);
				if (isEFGEnabled!=false){
					jbEFG.setText("Enable EFG");
				} else {
					jbEFG.setText("Disable EFG");
				}
				
				//update();
			}
		});

		if (replayActionString != null && !replayActionString.equals("")){
				
			buttonPanel.add(jbEFG);
		}
		
		//dialogContent.add(b);
		
		getContentPane().add(buttonPanel,BorderLayout.SOUTH);
		
		
		Dimension dim = getPreferredSize();
		int x = (int) Math.round(dim.getWidth());
		int y = (int) Math.round(dim.getHeight());
		x=x+10;
		if (x > 300)
			x=300;
		y=30*(propertySize+4);
		if (y > 300)
			y=300;
		setSize(x,y);
		setVisible(true);
	}

}
